<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Admin_user extends CI_Controller {

	function __construct() { 
         parent::__construct(); 
		 $this->load->model('admin_user_model');	
    } 

	public function index()
	{
		$this->get_listdata();
	}
	
	public function get_listdata()
	{
		$data['page_title'] = 'Manage Users';
		$data['records'] =$this->admin_user_model->get_list(); 
		$this->load->view('admin/admin_user_view',$data);
	}

	public function getdata($id)
	{
		 $result = $this->admin_user_model->get_data($id); 
		 echo json_encode($result);
	}
	
	public function add() { 
		$edit_id = $this->input->post('edit_id', TRUE);
		//echo "<br>ID:$edit_id";
		
		//Redirect if NAN
		if (!is_numeric($edit_id)) $this->get_listdata();
		
		//Form Validation 
		if ($edit_id==0) $this->form_validation->set_rules('username', 'Username', 'required|is_unique[admin_user.username]',array('is_unique' => '%s is already registered.'));
		//else $this->form_validation->set_rules('username', 'Username', 'required');
		if ($edit_id==0) $this->form_validation->set_rules('password', 'Password', 'required');
		$this->form_validation->set_rules('full_name', 'Full Name', 'required');
		if ($edit_id==0) $this->form_validation->set_rules('email', 'Email', 'required|is_unique[admin_user.email]',array('is_unique' => '%s is already registered.'));
		else $this->form_validation->set_rules('email', 'Email', 'required');

		if ($this->form_validation->run() == FALSE)
		{
			//echo "<br>Validation Not Success";
			$this->get_listdata();
		}
		else //If validation success
		{
			//echo "<br>Validation Success";
			 $status =$this->input->post('status');
			 if(empty($status) || $status == NULL || $status == "") $status = 0;
			 else $status = 1;

			//Get Current Date and Time
			$this->load->helper('functions');
			//echo get_current_datetime();
			$date_added = get_current_datetime();
			
			if($edit_id==0) //Add
			{
				$input_data = array( 
					'full_name' => $this->input->post('full_name', TRUE),
					'username' => $this->input->post('username', TRUE),
					'password' => md5($this->input->post('password', TRUE)),
					// 'user_type' => $this->input->post('user_type', TRUE),
					'user_type' => 'user',
					'email' => $this->input->post('email', TRUE),
					'mobile' => $this->input->post('mobile', TRUE),
					'address' => $this->input->post('address', TRUE), 
					'status' => 1,
					'date_added' => $date_added,
					'date_updated' => $date_added,
				); 
				$res = $this->admin_user_model->insert($input_data); 
				$data['success_message'] = 'Record added successfully';
				$data['error_message'] = '';
				
			}
			else //Edit
			{
				$input_data = array( 
					'full_name' => $this->input->post('full_name', TRUE),
					// 'user_type' => $this->input->post('user_type', TRUE),
					'user_type' => 'user',
					'email' => $this->input->post('email', TRUE),
					'mobile' => $this->input->post('mobile', TRUE),
					'address' => $this->input->post('address', TRUE), 
					'status' => 1,
					'date_updated' => $date_added
				);
				$res = $this->admin_user_model->update($input_data,$edit_id);
				$data['success_message'] = 'Record updated successfully';
				$data['error_message'] = '';
			}
			 //$this->get_listdata();
			 $this->session->set_userdata('display_message', $data);
			 if($this->input->post('isProfile', TRUE)==1)
			 {
				 $data = $this->session->userdata['logged_in'];
				 $data['full_name'] = $this->input->post('full_name', TRUE);
				 $this->session->set_userdata('logged_in',$data);
			 }
			 if($this->input->post('isProfile', TRUE)==1) redirect('admin_user/profile/'.$edit_id);
			 else redirect('admin_user');
			}
		  } 
		 
	public function delete($id)
	{    //echo "manoj"; die();
		 $res = $this->admin_user_model->delete($id); 
		 if($res)
		 {
			 $data['success_message'] = 'Record delete successfully';
			 $this->session->set_userdata('display_message', $data);
		 }
		 else
		 {
			 $data['error_message'] = 'You can not delete this record. because you logged in with this user';
			 $this->session->set_userdata('display_message', $data);
		 }
			 redirect('admin_user');
		 
	}
	
	public function setstatus()
	{
		$id = $this->input->post('id');
		$current_st = $this->input->post('current_st');
		if($current_st == 1) {
			$statusData = array('status' => 0);
		} else {
			$statusData = array('status' => 1);
		}
		$update = $this->admin_user_model->update_status($id, $statusData);
		echo $update;
	}
	
	public function profile($id)
	{
		$data['page_title'] = 'My Profile';
		$data['records'] = $this->admin_user_model->get_data($id); 
		$data['upload_error'] = '';
		$this->load->view('admin/profile_view',$data);
	}
	
	public function upload_image($user_id) 
	{
		$data['page_title'] = "My Profile";
		$data['records'] = $this->admin_user_model->get_data($user_id); 
		
		$this->load->library('upload');
		
		if(!is_dir('./media/users')){
			// echo "here not";
			mkdir('./media/users');
		}
		// else echo "here yes ";
		$uploadPath = 'media/users/';
		
		$config['upload_path'] = $uploadPath;
		$config['allowed_types'] = 'gif|jpg|jpeg|png';
		$config['max_size'] = '5120';
		$config['encrypt_name'] = TRUE;
		$this->upload->initialize($config);
		// echo " here1";
		if (!$this->upload->do_upload('userfile')) {
			// echo "here2";
			$data['upload_error'] = $this->upload->display_errors();
			$this->load->view('admin/profile_view', $data);
		} else {
		// echo "here3";
			$user = $this->admin_user_model->get_data($user_id);
			$image = $user->profile_image;
			if($image) {
				unlink($image);
			}
			
			$imageData = $this->upload->data();
			$imagePath = $imageData['file_name'];
		
			$usersData = array(
				'profile_image' => $imagePath
			);
			
			$this->admin_user_model->update($usersData,$user_id);
			$data = $this->session->userdata['logged_in'];
			 $data['profile_image'] = $imagePath;
			 $this->session->set_userdata('logged_in',$data);
			redirect('admin_user/profile/'.$user_id);
		}
	}

	function changepw($id)
	{
		$data['page_title'] = 'My Profile - Change Password';
		$this->load->view('admin/changepw_view', $data);
	}


	public function update_pw($id) { 
		
		//Form Validation 
		$this->form_validation->set_rules('password', 'Password', 'required');

		if ($this->form_validation->run() == FALSE)
		{
			//echo "<br>Validation Not Success";
			$this->changepw($id);
		}
		else //If validation success
		{
			//echo "<br>Validation Success";
				$input_data = array( 
					'password' => md5($this->input->post('password', TRUE)),
				);
				$res = $this->admin_user_model->update($input_data,$id);
				$data['success_message'] = 'Password changed successfully';
				$data['error_message'] = '';
			 //$this->get_listdata();
			 $this->session->set_userdata('display_message', $data);
			 $this->changepw($id);
		}
	} 
	
	public function get_list()
	{
		$list = $this->admin_user_model->get_datatables(); 
		$data = array();
		$status = array();
		$no = $_POST['start'];
		foreach ($list as $r) {
			$primary_id = $r->admin_user_id;
			$no++;
			$row = array();
 			$row[] = $no;
			$row[] = '<span class="mytooltip" >                     
                        <a href="javascript:void(0)" onClick="doView('.$primary_id.');" class="btn btn-primary btn-xs" data-toggle="modal" data-target="#model_view"> <i class="fa fa-eye"></i></a>
                         <span class="tooltiptext">View</span>
                        </span>
                         <span class="mytooltip" >                     
                        <a href="javascript:void(0)" onClick="doEdit('. $primary_id.');" class="btn btn-dark btn-xs" data-toggle="modal" data-target="#model_add"> <i class="fa fa-pencil"></i></a>
                         <span class="tooltiptext">Edit</span>
                        </span>
                         <span class="mytooltip" >                     
                        <a href="javascript:void(0)" onClick="DeleteSet('.$primary_id.');" class="btn btn-danger btn-xs" data-toggle="modal" data-target="#model_delete"> <i class="fa fa-trash-o"></i></a>
                         <span class="tooltiptext">Delete</span>
                        </span>';
			$row[] = $r->username;
			$row[] = $r->full_name;
			$row[] = $r->email;
			$row[] = $r->mobile;
			$row[] = $r->user_type;
			// if(intval($r->user_type)==1)
			// {
			// 	$row[] = "<h4><label class='label label-info'>super_admin</label></h4>";
			// }else{
			// 	$row[] = "<h4><label class='label label-warning'>company</label></h4>";
			// }
			 
			if($r->date_added=='0000-00-00 00:00:00'){
                $row[] = '';
            }else{
                $row[] = $r->date_added;
            } 
			if($r->date_updated=='0000-00-00 00:00:00'){
                $row[] = '';
            }else{
                $row[] = $r->date_updated;
            }
			if($r->status==1)
			{
				$status = "<label class='label label-success'>Active</label>";
			}else{
				$status = "<label class='label label-danger'>Inactive</label>";
			}
			$row[] = '<h4><a href="javascript:void(0)" >'.$status.'</a></h4>';
					
			$data[] = $row;
		}
		$output = array(
						"draw" => $_POST['draw'],
						"recordsTotal" => $this->admin_user_model->count_all(),
						"recordsFiltered" => $this->admin_user_model->count_filtered(),
						"data" => $data
				);
		//output to json format
		echo json_encode($output);
	}

		  
}
?>