<?php
defined('BASEPATH') or exit('No direct script access allowed');
require APPPATH . '/libraries/REST_Controller.php';
class Api extends REST_Controller
{
    private $secret_key = 'Aimsoft';
    public function __construct()
    {
        parent::__construct();
        date_default_timezone_set('Asia/Kolkata');
        $this->load->model('Api_model');
        $this->load->model('User_model');
        $this->load->model('Post_model');
        $this->load->model('Post_image_model');
        $this->load->helper(array('form', 'url'));
        $this->load->library('form_validation');
        $this->load->database();
        $this->load->library('email');
        $this->load->helper('string');
        $encrypted_token = $this->input->get_request_header('token');
        $authenticated = $this->verify_token($encrypted_token);
        if (!$authenticated) {
            $this->output
                ->set_content_type('application/json')
                ->set_status_header(401)
                ->set_output(json_encode(['error' => 'Unauthorized']));
            exit;
        }
    }
    public function register_post()
    {
        $status = 1;
        //Get Current Date and Time
        $this->load->helper('functions');
        //echo get_current_datetime();
        $date_added = get_current_datetime();
        $this->form_validation->set_rules('first_name', 'First Name', 'required');
        $this->form_validation->set_rules('last_name', 'Last Name', 'required');
        $this->form_validation->set_rules('email', 'Email', 'required|valid_email|is_unique[users.email]');
        $this->form_validation->set_rules('phone', 'Phone', 'required|is_unique[users.phone]');
        $this->form_validation->set_rules('password', 'Password', 'required');
        if ($this->form_validation->run()) {
            $input_data = array(
                'first_name' => $this->input->post('first_name', true),
                'last_name' => $this->input->post('last_name', true),
                'email' => $this->input->post('email', true),
                'phone' => $this->input->post('phone', true),
                'password' => md5($this->input->post('password', true)),
                'status' => $status,
                'date_added' => $date_added,
                'date_updated' => $date_added,
            );
            $res = $this->User_model->insert($input_data);
            $insert_id = $this->db->insert_id();
            $query = $this->db->get_where('users', array('user_id' => $insert_id));
            $row = $query->row();
                if ($res == true) {
                    $data['success_message'] = 'User registered successfully';
                } else {
                    $data['error_message'] = 'Unable to register, Please try again';
                }            

            if (isset($row->dob) && !empty($row->dob)) {
                $dob = $row->dob;
            } else {
                $dob = '';
            }

            $responseData = array(
                'status' => 'success',
                'message' => $data['success_message'],
                'userInfo' => array(
                    'user_id' => $row->user_id,
                    'first_name' => $row->first_name,
                    'last_name' => $row->last_name,
                    'email' => $row->email,
                    'phone' => $row->phone,
                    'address' => $row->address,
                    'city' => $row->city,
                    'state' => $row->state,
                    'zipcode' => $row->zipcode,
                    'dob' => $row->dob,
                    'status' => $row->status,
                    'date_added' => $row->date_added,
                    'date_updated' => $row->date_updated,
                ),
            );
            return $this->response($responseData, 200);
        } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Validation failed please check your input field',
                );
            return $this->response($responseData);
        }
    }


    public function contact_us_post()
    {
        $status = 1;
        //Get Current Date and Time
        $this->load->helper('functions');
        //echo get_current_datetime();
        $date_added = get_current_datetime();
        $this->form_validation->set_rules('user_id', 'User Name', 'required');
        $this->form_validation->set_rules('email_id', 'Password', 'required');
        $this->form_validation->set_rules('message', 'Password', 'required');
        if ($this->form_validation->run()) {
            $input_data = array(
                'user_id' => $this->input->post('user_id', true),
                'email_id' => $this->input->post('email_id', true),
                'message' => $this->input->post('message', true),
                'status' => $status,
                'date_added' => $date_added,
                'date_updated' => $date_added,
            );
            $res = $this->Api_model->insert_contact($input_data);
            if(!empty($this->input->post('language_id', true))){
                $res = $this->Api_model->get_label_value('message_is_successfully_submitted',$this->input->post('language_id', true));
                $responseData = array(
                    'status' => 'success',
                    'message' => $res->label_element_value,
                );
                return $this->response($responseData);
            }
            else{
                $responseData = array(
                    'status' => 'success',
                    'message' => 'Message is successfully submitted',
                );
                return $this->response($responseData);
            }
        } else {
            if(!empty($this->input->post('language_id', true)))
            {
                $res = $this->Api_model->get_label_value('validation_failed_please_check_your_input_field',$this->input->post('language_id', true));
                $responseData = array(
                    'status' => 'error',
                    'message' => $res->label_element_value
                );
            }
            else{
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Validation failed please check your input field',
                );
            }
            return $this->response($responseData);
        }
    }

    public function login_post()
    {
        $email = $this->post('email');
        $password = $this->post('password');
        $this->form_validation->set_rules('email', 'Email', 'required');
        $this->form_validation->set_rules('password', 'Password', 'required');
        if ($this->form_validation->run()) {
            $data = array('email' => $email, 'password' => md5($password), 'status' => 1);
            $loginStatus = $this->Api_model->checkLogin($data);
            if ($loginStatus != false) {
                $userInfo = [
                    'user_id' => $loginStatus->user_id,
                    'first_name' => $loginStatus->first_name,
                    'last_name' => $loginStatus->last_name,
                    'email' => $loginStatus->email,
                    'phone' => $loginStatus->phone,
                    'address' => $loginStatus->address,
                    'city' => $loginStatus->city,
                    'state' => $loginStatus->state,
                    'zipcode' => $loginStatus->zipcode,
                    'dob' => $loginStatus->dob,
                    'status' => $loginStatus->status,
                    'profile_image' => $loginStatus->profile_image,
                    'date_added' => $loginStatus->date_added,
                    'date_updated' => $loginStatus->date_updated,
                ];
                $responseData = array(
                    'status' => 'success',
                    'base_url' => base_url().'media/profile_images/',
                    'userInfo' => $userInfo,
                    //  'userInfo' => $userInfo,
                );
                return $this->response($responseData, 200);
            } else {
                    $responseData = array(
                        'status' => 'error',
                        'message' => 'Invalid Email Or Password',
                    );
                    return $this->response($responseData);
            }
        } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Invalid Email Or Password',
                );
            return $this->response($responseData);
        }
    }
    public function forgotpw_post()
    {
        // $this->load->library('email');
        // $this->load->config('email');
        $this->load->library('form_validation');
        $this->load->helper('string');
        // echo random_string('alnum', 16);
        // die();
        $email = $this->post('email');
        $this->form_validation->set_rules('email', 'Email', 'required');
        if ($this->form_validation->run()) {
            $data = array('email' => $email);
            $loginStatus = $this->Api_model->checkForgotPW($data);
            if ($loginStatus != false) {
                    $responseData = array(
                        'status' => 'success',
                        'message' => 'Mail Sent',
                    );
                return $this->response($responseData);

            } else {
                    $responseData = array(
                        'status' => 'error',
                        'message' => 'Email not found',
                    );
                return $this->response($responseData);
            }
        } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Invalid Email',
                );
            return $this->response($responseData);
        }
    }
    public function load_profile_post()
    {
        //Form Validation
        $this->form_validation->set_rules('user_id', 'user id', 'required');
        if ($this->form_validation->run() == false) {
            $responseData = array(
                'status' => 'fail',
                'message' => 'Validation failed please check your input field',
            );
            return $this->response($responseData, 200);
        } else //If validation success
        {
            $user_id = $this->input->post('user_id', true);
            $profile_data = $this->Api_model->load_profile_data($user_id);
            $new_list['user_id'] = $profile_data[0]['user_id'];
            $new_list['first_name'] = $profile_data[0]['first_name'];
            $new_list['last_name'] = $profile_data[0]['last_name'];
            $new_list['phone'] = $profile_data[0]['phone'];
            $new_list['dob'] = $profile_data[0]['dob'];
            $new_list['email'] = $profile_data[0]['email'];
            $new_list['address'] = $profile_data[0]['address'];
            $new_list['state'] = $profile_data[0]['state'];
            $new_list['city'] = $profile_data[0]['city'];
            $new_list['state_code'] = $profile_data[0]['state_code'];
            $new_list['city_code'] = $profile_data[0]['city_code'];
            $new_list['zipcode'] = $profile_data[0]['zipcode'];
            $new_list['status'] = $profile_data[0]['status'];
            $new_list['profile_image'] = $profile_data[0]['profile_image'];
            $new_list['date_added'] = $profile_data[0]['date_added'];
            $new_list['date_updated'] = $profile_data[0]['date_updated'];
            
            if(!empty($profile_data)){
                $responseData = array(
                    'status' => 'success',
                    'base_url' => base_url() . 'media/profile_images/',
                    'data' => $new_list,
                );
            } else {
                $responseData = array(
                    'status' => 'error',
                    'data' => 'No records found',
                );
            }
            return $this->response($responseData, 200);
        }
    }
    public function manage_profile_post()
    {
        $user_id = $this->input->post('user_id', true);
        //Form Validation
        $this->form_validation->set_rules('user_id', 'User Id', 'required');
        $this->form_validation->set_rules('first_name', 'First Name', 'required');
        $this->form_validation->set_rules('last_name', 'Last Name', 'required');
        $this->form_validation->set_rules('email', 'Email', 'required|valid_email');
        $this->form_validation->set_rules('phone', 'Phone', 'required');
        $this->form_validation->set_rules('dob', 'DOB', 'required');
        $this->form_validation->set_rules('address', 'Address', 'required');
        $this->form_validation->set_rules('city', 'City', 'required');
        $this->form_validation->set_rules('state', 'State', 'required');
        $this->form_validation->set_rules('state_code', 'State code', 'required');
        $this->form_validation->set_rules('city_code', 'City code', 'required');
        $this->form_validation->set_rules('zipcode', 'Zip code', 'required');

        if ($this->form_validation->run() == false) {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Validation failed please check your input field',
                );
            
            return $this->response($responseData);
        } else //If validation success
        {
            $this->load->helper('functions');
            //echo get_current_datetime();
            $date_added = get_current_datetime();

            $input_data = array(
                'first_name' => $this->input->post('first_name', TRUE),
                'last_name' => $this->input->post('last_name', TRUE),
                'address' => $this->input->post('address', TRUE),
                'state' => $this->input->post('state', TRUE),
                'city' => $this->input->post('city', TRUE),
                'state_code' => $this->input->post('state_code', TRUE),
                'city_code' => $this->input->post('city_code', TRUE),
                'zipcode' => $this->input->post('zipcode', TRUE),
                'phone' => $this->input->post('phone', TRUE),
                'dob' => $this->input->post('dob', TRUE),
                'email' => $this->input->post('email', TRUE),
                'date_updated' => $date_added
            );
            $res = $this->User_model->update($input_data, $user_id);
                if($res == true){
                    $responseData = array(
                        'status' => 'success',
                        'message' => 'Profile Updated successfully',
                    );
                }
            return $this->response($responseData);
        }
    }
    public function manage_profile_image_post()
    {
        $user_id = $this->input->post('user_id', true);
        //Form Validation
        $this->form_validation->set_rules('user_id', 'User id', 'required');
        if ($this->form_validation->run() == false) {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Validation failed please check your input field',
                );
            return $this->response($responseData);
        } else //If validation success
        {
            $profile_data = $this->Api_model->load_profile_data($user_id);
            if (isset($profile_data[0]['profile_image'])) {
                $image_path = './media/profile_images/' . $profile_data[0]['profile_image'];
                if (file_exists($image_path)) {
                    unlink($image_path);
                }
            }
            $this->load->library('upload');
            if (!is_dir('./media/profile_images')) {
                mkdir('./media/profile_images');
            }
            $uploadPath = 'media/profile_images/';
            $config['upload_path'] = $uploadPath;
            $config['allowed_types'] = 'gif|jpg|png';
            $config['max_size'] = '50000';
            $config['encrypt_name'] = true;
            $this->upload->initialize($config);
            if (!$this->upload->do_upload('profile_image')) {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Please upload a image in this format gif|jpg|png'
                );
            return $this->response($responseData);
            } else {
                $Profile_data = $this->upload->data();
                $profile_image_name = $Profile_data['file_name'];
                //Get Current Date and Time
                $this->load->helper('functions');
                //echo get_current_datetime();
                $date_added = get_current_datetime();
                $input_data = array(
                    'date_updated' => $date_added,
                    'profile_image' => $profile_image_name,
                );
                $res = $this->User_model->update($input_data, $user_id);
                if($res == true){
                    $responseData = array(
                        'status' => 'success',
                        'message' => 'Profile Image Updated successfully',
                    );
                }
            return $this->response($responseData);
            }
        }
    }
    public function changePwd_post()
    {
        $user_id = $this->post('user_id');
        $old_password = $this->post('old_password');
        $new_password = $this->post('new_password');
        $this->form_validation->set_rules('user_id', 'Patient Id', 'required');
        $this->form_validation->set_rules('old_password', 'Old Password', 'required');
        $this->form_validation->set_rules('new_password', 'New Password', 'required');
        $date_added = date('Y-m-d H:i:s');
        if ($this->form_validation->run()) {
            $data = array('user_id' => $user_id, 'password' => md5($old_password));
            $loginStatus = $this->Api_model->change_password($data);
            if ($loginStatus != false) {
                $date = [
                    'password' => md5($new_password),
                    'date_updated' => $date_added,
                ];
                $this->Api_model->update_password($user_id, $date);
                    $responseData = array(
                        'status' => 'success',
                        'message' => 'Password Updated',
                    );
                return $this->response($responseData);
            } else {
                    $responseData = array(
                        'status' => 'error',
                        'message' => 'Invalid Old Password',
                    );
                return $this->response($responseData);
            }
        } else {
            if (!empty($this->input->post('language_id', true))) {
                $res = $this->Api_model->get_label_value('invalid_password', $this->input->post('language_id', true));
                $responseData = array(
                    'status' => 'error',
                    'message' => $res->label_element_value
                );
            } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Invalid Password',
                );
            }
            return $this->response($responseData);
        }
    }
    public function upload_images1_post()
    {
        $this->form_validation->set_rules('user_id', 'user id', 'required');
        $this->form_validation->set_rules('post_id', 'post id', 'required');
        $this->form_validation->set_rules('default_image', 'default image', 'required');
        if ($this->form_validation->run() == false) {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Validation failed please check your input field',
                );
            return $this->response($responseData);
        } else {
                $this->load->library('upload');
                if (!is_dir('./media/post_images')) {
                    mkdir('./media/post_images');
                }
                $uploadPath = 'media/post_images/';
                $config['upload_path'] = $uploadPath;
                $config['allowed_types'] = 'jpg|jpeg|png';
                $config['encrypt_name'] = true;
                $this->upload->initialize($config);
                if (!$this->upload->do_upload('image')) {
                        $responseData = array(
                            'status' => 'error',
                            'message' => 'Please upload an image file',
                        );
                    return $this->response($responseData);
                } else {
                    $VideoData = $this->upload->data();
                    $imageName = $VideoData['file_name'];
                    $this->load->helper('functions');
                    $date_added = get_current_datetime();
                    $input_data = array(
                        'user_id' => $this->input->post('user_id'),
                        'post_id' => $this->input->post('post_id'),
                        'file_path' => $imageName,
                        'default_image' => $this->input->post('default_image'),
                        'status' => 1,
                        'date_added' => $date_added,
                        'date_updated' => $date_added,
                    );
                    $res = $this->db->insert('post_image', $input_data);
                    // $insert_id = $this->db->insert_id();
                    // $query = $this->db->get_where('upload_videos', array('video_id' => $insert_id));
                    // $row = $query->row();
                        if($res == TRUE)
                        {
                            $responseData = array(
                                'status' => 'success',
                                'message' => 'Image Uploaded successfully',
                            );
                        }
                        else{
                            $responseData = array(
                                'status' => 'error',
                                'message' => 'Please try again',
                            );
                        }
                    return $this->response($responseData);
                }
        }
    }
    public function upload_images_post()
    {
        $this->form_validation->set_rules('user_id', 'user id', 'required');
        $this->form_validation->set_rules('post_id', 'post id', 'required');
        if ($this->form_validation->run() == false) {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Validation failed please check your input field',
                );
            return $this->response($responseData);
        } else {
            $this->load->helper('functions');
            $date_added = get_current_datetime();
            $count = count($_FILES['image']['name']);

            for ($i = 0; $i < $count; $i++) {

                if (!empty($_FILES['image']['name'][$i])) {

                    $_FILES['file']['name'] = $_FILES['image']['name'][$i];
                    $_FILES['file']['type'] = $_FILES['image']['type'][$i];
                    $_FILES['file']['tmp_name'] = $_FILES['image']['tmp_name'][$i];
                    $_FILES['file']['error'] = $_FILES['image']['error'][$i];
                    $_FILES['file']['size'] = $_FILES['image']['size'][$i];

                    $config['upload_path'] = 'media/post_images/';
                    $config['allowed_types'] = 'jpg|jpeg|png|gif';
                    $config['file_name'] = $_FILES['image']['name'][$i];

                    if($i == 0) {
                        $default_image = 1;
                    }else {
                        $default_image = 0;
                    }
                    $this->load->library('upload', $config);

                    if ($this->upload->do_upload('file')) {
                        $uploadData = $this->upload->data();
                        $filename = $uploadData['file_name'];

                        $input_data = array(
                            'user_id' => $this->input->post('user_id'),
                            'post_id' => $this->input->post('post_id'),
                            'file_path' => $filename,
                            'default_image' => $default_image,
                            'status' => 1,
                            'date_added' => $date_added,
                            'date_updated' => $date_added,
                        );
                        $res = $this->db->insert('post_image', $input_data);
                    }
                }
            }
            if ($res == TRUE) {
                $responseData = array(
                    'status' => 'success',
                    'message' => 'Image Uploaded successfully',
                );
            } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Please try again',
                );
            }
            return $this->response($responseData);
        }
    }
    public function select_default_image_post()
    {
        $post_id = $this->input->post('post_id', true);
        //Form Validation
        $this->form_validation->set_rules('post_id', 'post id', 'required');
        $this->form_validation->set_rules('user_id', 'user id', 'required');
        $this->form_validation->set_rules('image_index', 'index', 'required');

        if ($this->form_validation->run() == false) {
            $responseData = array(
                'status' => 'error',
                'message' => 'Validation failed please check your input field',
            );

            return $this->response($responseData);
        } else //If validation success
        {
            $this->load->helper('functions');
            //echo get_current_datetime();
            $date_added = get_current_datetime();

            $images = $this->Api_model->get_post_images($post_id);
            foreach($images as $key => $item){
                if($key == $this->post('image_index'))
                {
                    $input_data = array(
                        'user_id' => $this->post('user_id'),
                        'post_id' => $this->post('post_id'),
                        'default_image' => 1,
                        'date_updated' => $date_added
                    );
                    $this->db->set($input_data);
                    $this->db->where("post_image_id", $images[$key]['post_image_id']);
                    $res = $this->db->update("post_image", $input_data);
                }
                else
                {
                    $input_data = array(
                        'user_id' => $this->post('user_id'),
                        'post_id' => $this->post('post_id'),
                        'default_image' => 0,
                    );
                    $this->db->set($input_data);
                    $this->db->where("post_image_id", $images[$key]['post_image_id']);
                    $res = $this->db->update("post_image", $input_data);
                }
            }
            if ($res == true) {
                $responseData = array(
                    'status' => 'success',
                    'message' => 'Default selected',
                );
            }
            else{
                $responseData = array(
                    'status' => 'error',
                    'message' => 'No results found',
                );
            }
            return $this->response($responseData);
        }
    }
    public function post_post()
    {

        $this->form_validation->set_rules('user_id', 'user_id', 'required');
        $this->form_validation->set_rules('title', 'title', 'required');
        $this->form_validation->set_rules('description', 'description', 'required');
        $this->form_validation->set_rules('material_type', 'material_type', 'required');
        $this->form_validation->set_rules('material_name', 'material_name', 'required');
        $this->form_validation->set_rules('location', 'location', 'required');

        $this->load->helper('functions');
        $date_added = get_current_datetime();

        if ($this->form_validation->run()) {
            $data = [
                'user_id' => $this->post('user_id'),
                'title' => $this->post('title'),
                'description' => $this->post('description'),
                'material_type' => $this->post('material_type'),
                'material_name' => $this->post('material_name'),
                'location' => $this->post('location'),
                'status' => 1,
                'date_added' => $date_added,
                'date_updated' => $date_added

            ];

            $res = $this->db->insert('post', $data);
            $insert_id = $this->db->insert_id();
            $query = $this->db->get_where('post', array('post_id' => $insert_id));
            $row = $query->row();
            if ($res) {
                $responseData = array(
                    'status' => 'success',
                    'message' => 'Post Added successfully',
                    'post_id' => $row->post_id
                );
            } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Please try again',
                );
            }
            return $this->response($responseData);
        } else {
            $responseData = array(
                'status' => 'error',
                'message' => 'Validation failed please check your input field',
            );
            return $this->response($responseData);
        }
    }
    public function post_edit_post()
    {
        $post_id = $this->input->post('post_id', true);
        //Form Validation
        $this->form_validation->set_rules('post_id', 'post id', 'required');
        $this->form_validation->set_rules('user_id', 'user id', 'required');
        $this->form_validation->set_rules('title', 'title', 'required');
        $this->form_validation->set_rules('description', 'description', 'required');
        $this->form_validation->set_rules('material_type', 'material_type', 'required');
        $this->form_validation->set_rules('location', 'location', 'required');

        if ($this->form_validation->run() == false) {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Validation failed please check your input field',
                );
            
            return $this->response($responseData);
        } else //If validation success
        {
            $this->load->helper('functions');
            //echo get_current_datetime();
            $date_added = get_current_datetime();

            $input_data = array(
                'user_id' => $this->post('user_id'),
                'title' => $this->post('title'),
                'description' => $this->post('description'),
                'material_type' => $this->post('material_type'),
                'location' => $this->post('location'),
                'status' => 1,
                'date_updated' => $date_added

            );
            $res = $this->Post_model->update($input_data, $post_id);
                if($res == true){
                    $responseData = array(
                        'status' => 'success',
                        'message' => 'Post Updated successfully',
                    );
                }
            return $this->response($responseData);
        }
    }
    public function post_delete_post()
    {
        $post_id = $this->input->post('post_id');
        $this->form_validation->set_rules('post_id', 'User Id', 'required');
        if ($this->form_validation->run()) {
            $res = $this->Post_model->delete($post_id);
            $this->db->where('post_id', $post_id);
            $this->db->delete("my_favourite");
            if ($res == true) {
                $responseData = array(
                    'status' => 'success',
                    'message' => 'Post deleted successfully',
                );
            return $this->response($responseData);
            } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Failed to delete post',
                );
            return $this->response($responseData);
            }
        } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Validation failed please check your input field',
                );
            return $this->response($responseData);
        }
    }
    public function delete_image_post()
    {
        $post_id = $this->input->post('post_image_id');
        $this->form_validation->set_rules('post_image_id', 'Post image Id', 'required');
        if ($this->form_validation->run()) {
            $res = $this->Post_image_model->delete($post_id);
            if ($res == true) {
                $responseData = array(
                    'status' => 'success',
                    'message' => 'Image deleted successfully',
                );
            return $this->response($responseData);
            } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Failed to delete image',
                );
            return $this->response($responseData);
            }
        } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Validation failed please check your input field',
                );
            return $this->response($responseData);
        }
    }
    public function delete_account_post()
    {
        // change user status 
        $user_id = $this->input->post('user_id');
        $this->form_validation->set_rules('user_id', 'User Id', 'required');
        if ($this->form_validation->run()) {
            $res = $this->Api_model->delete_account($user_id);
            if ($res == true) {
                $responseData = array(
                    'status' => 'success',
                    'message' => 'Account Deactivated',
                );
            return $this->response($responseData);
            } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Failed to deactivate account',
                );
            return $this->response($responseData);
            }
        } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Validation failed please check your input field',
                );
            return $this->response($responseData);
        }
    }
    public function postlist_post()
    {
            $user_data = $_GET;
            $get_data['counts_per_page'] = $user_data['counts_per_page'];
            $get_data['current_page'] = $user_data['current_page'];
            $user_id = $this->input->post('user_id');
            $material_list = $this->input->post('material_type');
            $array1 = json_decode($material_list, true);
            $search = array(
                'search_text' => $this->input->post('search_text'),
                'location' => $this->input->post('location'),
                'material_type' => $array1,
            );
            $orderList = $this->Api_model->get_post($get_data, $search);
            foreach ($orderList['post_list'] as $list) {
                $current_time = new DateTime('now');
                $datetime_obj = new DateTime($list['date_added']);
                $interval = $datetime_obj->diff($current_time);
                if ($interval->y > 0) {
                    $time = $interval->y . ' year' . ($interval->y > 1 ? 's' : '') . ' ago';
                } elseif ($interval->m > 0) {
                    $time = $interval->m . ' month' . ($interval->m > 1 ? 's' : '') . ' ago';
                } elseif ($interval->d > 0) {
                    $time = $interval->d . ' day' . ($interval->d > 1 ? 's' : '') . ' ago';
                } elseif ($interval->h > 0) {
                    $time = $interval->h . ' hour' . ($interval->h > 1 ? 's' : '') . ' ago';
                } elseif ($interval->i > 0) {
                    $time = $interval->i . ' minute' . ($interval->i > 1 ? 's' : '') . ' ago';
                } else {
                    $time = 'just now';
                }
                if(!empty($user_id)) {
                    $data = array('user_id' => $user_id, 'post_id' => $list['post_id']);
                    $res = $this->Api_model->is_fav($data);
                    if ($res != false) {
                        if($res->status == 1) {
                            $fav = $res->status;
                        } else {
                            $fav = 0;
                        }
                    } else {
                        $fav = 0;
                    }
                } else {
                    $responseData = array(
                        'status' => 'success',
                        'message' => 'Validation failed please check your input field',
    
                    );
                    return $this->response($responseData);
                }
                $order = array(
                    'post_id' => $list['post_id'],
                    'user_id' => $list['user_id'],
                    'first_name' => $list['first_name'],
                    'last_name' => $list['last_name'],
                    'title' => $list['title'],
                    'description' => $list['description'],
                    'location' => $list['location'],
                    'status' => $list['status'],
                    'is_favourite' => $fav,
                    'time' => $time,
                    'post_images' => ""
                );
                $items = $this->Api_model->get_post_images($list['post_id']);
                if(!empty($items)){
                    foreach ($items as $item) {
                        if($item['default_image'] == 1)
                        {
                            $order['post_images'] = base_url() . 'media/post_images/'.$item['file_path'];
                            
                        }
                    }
                }
            
                $newlist[] = $order;
            } 
            if (!empty($orderList['post_list'])) {

                $responseData = array(
                    'status' => 'success',
                    // 'base_url' => base_url() . 'media/post_images/',
                    'data'  => $newlist
                );
                return $this->response($responseData);
            } else {
                $responseData = array(
                    'status' => 'success',
                    'message' => 'No Records found',

                );
                return $this->response($responseData);
            }
    }
    public function material_list_get()
    {
        $user_data = $_GET;
        $get_data['counts_per_page'] = $user_data['counts_per_page'];
        $get_data['current_page'] = $user_data['current_page'];
        $material_list = $this->Api_model->get_materials($get_data);
        // echo "<pre>";
        // print_r($material_list['material_list']);
        // die();
        foreach ($material_list['material_list'] as $list) {
            $new_list[] = $list;
        }
        if (!empty($material_list['material_list'])) {

            $responseData = array(
                'status' => 'success',
                'data'  => $new_list
            );
            return $this->response($responseData);
        } else {
            $responseData = array(
                'status' => 'error',
                'message' => 'No Results found',

            );
            return $this->response($responseData);
        }
    }
    public function my_post_post()
    {
        //Form Validation
        $this->form_validation->set_rules('user_id', 'user id', 'required');
        if ($this->form_validation->run() == false) {
            $responseData = array(
                'status' => 'fail',
                'message' => 'Validation failed please check your input field',
            );
            return $this->response($responseData, 200);
        } else //If validation success
        {
            $user_id = $this->input->post('user_id', true);
            $user_data = $_GET;
            $get_data['counts_per_page'] = $user_data['counts_per_page'];
            $get_data['current_page'] = $user_data['current_page'];
            $data = array('user_id' => $this->input->post('user_id', true));
            $post_list = $this->Api_model->my_post_data($get_data, $data);
            foreach ($post_list['post_list'] as $list) {
                $current_time = new DateTime('now');
                $datetime_obj = new DateTime($list['date_added']);
                $interval = $datetime_obj->diff($current_time);
                if ($interval->y > 0) {
                    $time = $interval->y . ' year' . ($interval->y > 1 ? 's' : '') . ' ago';
                } elseif ($interval->m > 0) {
                    $time = $interval->m . ' month' . ($interval->m > 1 ? 's' : '') . ' ago';
                } elseif ($interval->d > 0) {
                    $time = $interval->d . ' day' . ($interval->d > 1 ? 's' : '') . ' ago';
                } elseif ($interval->h > 0) {
                    $time = $interval->h . ' hour' . ($interval->h > 1 ? 's' : '') . ' ago';
                } elseif ($interval->i > 0) {
                    $time = $interval->i . ' minute' . ($interval->i > 1 ? 's' : '') . ' ago';
                } else {
                    $time = 'just now';
                }
                if(!empty($user_id)) {
                    $data = array('user_id' => $user_id, 'post_id' => $list['post_id']);
                    $res = $this->Api_model->is_fav($data);
                    if ($res != false) {
                        if($res->status == 1) {
                            $fav = $res->status;
                        } else {
                            $fav = 0;
                        }
                    } else {
                        $fav = 0;
                    }
                } else {
                    $responseData = array(
                        'status' => 'success',
                        'message' => 'Validation failed please check your input field',
    
                    );
                    return $this->response($responseData);
                }
                $order = array(
                    'post_id' => $list['post_id'],
                    'user_id' => $list['user_id'],
                    'title' => $list['title'],
                    'description' => $list['description'],
                    'location' => $list['location'],
                    'status' => $list['status'],
                    'time' => $time,
                    'is_favourite' => $fav,
                    'post_images' => ""
                );
                $items = $this->Api_model->get_post_images($list['post_id']);
                if(!empty($items)){
                    foreach ($items as $item) {
                        if($item['default_image'] == 1)
                        {
                            $order['post_images'] = base_url() . 'media/post_images/'.$item['file_path'];
                            
                        }
                    }
                }
            
                $newlist[] = $order;
            }
            if (!empty($post_list['post_list'])) {
    
                $responseData = array(
                    'status' => 'success',
                    'data'  => $newlist
                );
                return $this->response($responseData);
            } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'No Results found',
    
                );
                return $this->response($responseData);
            }
        }
    }
    public function post_details_post()
    {
        //Form Validation
        $this->form_validation->set_rules('post_id', 'post id', 'required');
        if ($this->form_validation->run() == false) {
            $responseData = array(
                'status' => 'fail',
                'message' => 'Validation failed please check your input field',
            );
            return $this->response($responseData, 200);
        } else //If validation success
        {
            $post_id = $this->input->post('post_id', true);
            $post_details = $this->Api_model->get_post_details($post_id);
            if(!empty($post_details))
            {
                $current_time = new DateTime('now');
                $datetime_obj = new DateTime($post_details['date_added']);
                $interval = $datetime_obj->diff($current_time);
                if ($interval->y > 0) {
                    $time = $interval->y . ' year' . ($interval->y > 1 ? 's' : '') . ' ago';
                } elseif ($interval->m > 0) {
                    $time = $interval->m . ' month' . ($interval->m > 1 ? 's' : '') . ' ago';
                } elseif ($interval->d > 0) {
                    $time = $interval->d . ' day' . ($interval->d > 1 ? 's' : '') . ' ago';
                } elseif ($interval->h > 0) {
                    $time = $interval->h . ' hour' . ($interval->h > 1 ? 's' : '') . ' ago';
                } elseif ($interval->i > 0) {
                    $time = $interval->i . ' minute' . ($interval->i > 1 ? 's' : '') . ' ago';
                } else {
                    $time = 'just now';
                }
                $order = array(
                    'post_id' => $post_details['post_id'],
                    'user_id' => $post_details['user_id'],
                    'title' => $post_details['title'],
                    'description' => $post_details['description'],
                    'material_name' => $post_details['material_name'],
                    'material_id' => $post_details['material_type'],
                    'location' => $post_details['location'],
                    'status' => $post_details['status'],
                    'time' => $time,
                    'post_image' => ""
                );
                $imgs = $this->Api_model->get_post_images($post_details['post_id']);
                if(!empty($imgs)){
                    foreach ($imgs as $img) {
                        if($img['default_image'] == 1)
                        {
                            $order['post_image'] = base_url() . 'media/post_images/'.$img['file_path'];
                            
                        }
                    }
                }
                $items = $this->Api_model->get_post_images($post_details['post_id']);
                if(!empty($items)){
                    foreach ($items as $item) {
                        $order['post_images'][] = array(
                            'post_image_id' => $item['post_image_id'],
                            'user_id' => $item['user_id'],
                            'post_id' => $item['post_id'],
                            'file_path' => base_url() . 'media/post_images/'.$item['file_path'],
                            'default_image' => $item['default_image'],
                            'status' => $item['status'],
                        );
                    }
                } else {
                    $order['post_images'] = array();
                }
            
                $newlist[] = $order;
            }
            if (!empty($post_details)) {

                $responseData = array(
                    'status' => 'success',
                    // 'base_url' => base_url() . 'media/post_images/',
                    'data'  => $order
                );
                return $this->response($responseData);
            } else {
                $responseData = array(
                    'status' => 'success',
                    'message' => 'No Records found',

                );
                return $this->response($responseData);
            }
        }
    }
    public function abuse_post()
    {
        $this->load->helper('functions');
        $date_added = get_current_datetime();
        $this->form_validation->set_rules('post_id', 'Post ID', 'required');
        $this->form_validation->set_rules('user_id', 'User ID', 'required');
        $this->form_validation->set_rules('reason', 'reason', 'required');
        if ($this->form_validation->run()) {
            $this->db->where('user_id', $this->input->post('user_id', true));
            $this->db->where('post_id', $this->input->post('post_id', true));
            $query = $this->db->get('abuse');
            if ($query->num_rows() > 0) {
                // Update the existing row
                $input_data = array(
                    'post_id' => $this->input->post('post_id', true),
                    'user_id' => $this->input->post('user_id', true),
                    'reason' => $this->input->post('reason', true),
                    'date_updated' => $date_added,
                );
                $this->db->where('user_id', $this->input->post('user_id', true));
                $this->db->where('post_id', $this->input->post('post_id', true));
                $result = $this->db->update('abuse', $input_data);
            } else {
                // Insert a new row
                $input_data = array(
                    'post_id' => $this->input->post('post_id', true),
                    'user_id' => $this->input->post('user_id', true),
                    'reason' => $this->input->post('reason', true),
                    'status' => 1,
                    'date_added' => $date_added,
                    'date_updated' => $date_added,
                );
                $result = $this->db->insert('abuse', $input_data);
            }
            if ($result > 0) {
                    $this->response([
                        'status' => 'success',
                        'message' => 'Commented',
                    ], REST_Controller::HTTP_OK);
            } else {
                    $this->response([
                        'status' => 'error',
                        'message' => 'Failed',
                    ], REST_Controller::HTTP_BAD_REQUEST);
            }
        } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Validation failed please check your input field',
                );
            return $this->response($responseData);
        }
    }
    public function my_favourite_post()
    {
        $this->load->helper('functions');
        $date_added = get_current_datetime();
        $this->form_validation->set_rules('post_id', 'Post ID', 'required');
        $this->form_validation->set_rules('user_id', 'User ID', 'required');
        $this->form_validation->set_rules('status', 'status', 'required');
        if ($this->form_validation->run()) {
            $this->db->where('user_id', $this->input->post('user_id', true));
            $this->db->where('post_id', $this->input->post('post_id', true));
            $query = $this->db->get('my_favourite');
            if ($query->num_rows() > 0) {
                // Update the existing row
                $input_data = array(
                    'post_id' => $this->input->post('post_id', true),
                    'user_id' => $this->input->post('user_id', true),
                    'status' => $this->input->post('status', true),
                    'date_updated' => $date_added,
                );
                $this->db->where('user_id', $this->input->post('user_id', true));
                $this->db->where('post_id', $this->input->post('post_id', true));
                $result = $this->db->update('my_favourite', $input_data);
                if($this->input->post('status', true) == 1){
                    $message = 'Added to Favourite';
                }else {
                    $message = 'Removed from Favourite';
                }
    
            } else {
                // Insert a new row
                $input_data = array(
                    'post_id' => $this->input->post('post_id', true),
                    'user_id' => $this->input->post('user_id', true),
                    'status' => $this->input->post('status', true),
                    'date_added' => $date_added,
                    'date_updated' => $date_added,
                );
                $result = $this->db->insert('my_favourite', $input_data);
                $message = 'Added to Favourite';
            }
            if ($result > 0) {
                    $this->response([
                        'status' => 'success',
                        'message' => $message,
                    ], REST_Controller::HTTP_OK);
            } else {
                    $this->response([
                        'status' => 'error',
                        'message' => 'Failed',
                    ], REST_Controller::HTTP_BAD_REQUEST);
            }
        } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Validation failed please check your input field',
                );
            return $this->response($responseData);
        }
    }
    public function favouritelist_post()
    {
        //Form Validation
        $this->form_validation->set_rules('user_id', 'user id', 'required');
        if ($this->form_validation->run() == false) {
            $responseData = array(
                'status' => 'fail',
                'message' => 'Validation failed please check your input field',
            );
            return $this->response($responseData, 200);
        } else //If validation success
        {
            $user_data = $_GET;
            $get_data['counts_per_page'] = $user_data['counts_per_page'];
            $get_data['current_page'] = $user_data['current_page'];
            $data = $this->input->post('user_id', true);
            $post_list = $this->Api_model->favouritelist_data($get_data, $data);
            foreach ($post_list['post_list'] as $list) {
                $current_time = new DateTime('now');
                $datetime_obj = new DateTime($list['time']);
                $interval = $datetime_obj->diff($current_time);
                if ($interval->y > 0) {
                    $time = $interval->y . ' year' . ($interval->y > 1 ? 's' : '') . ' ago';
                } elseif ($interval->m > 0) {
                    $time = $interval->m . ' month' . ($interval->m > 1 ? 's' : '') . ' ago';
                } elseif ($interval->d > 0) {
                    $time = $interval->d . ' day' . ($interval->d > 1 ? 's' : '') . ' ago';
                } elseif ($interval->h > 0) {
                    $time = $interval->h . ' hour' . ($interval->h > 1 ? 's' : '') . ' ago';
                } elseif ($interval->i > 0) {
                    $time = $interval->i . ' minute' . ($interval->i > 1 ? 's' : '') . ' ago';
                } else {
                    $time = 'just now';
                }
                $this->db->select('u.first_name, u.last_name');
                $this->db->from('post as p');
                $this->db->where('post_id', $list['post_id']);
                $this->db->join('users as u', 'u.user_id = p.user_id', 'left');
                $result = $this->db->get()->row_array();
                $order = array(
                    'post_id' => $list['post_id'],
                    'user_id' => $list['user_id'],
                    'first_name' => $result['first_name'],
                    'last_name' => $result['last_name'],
                    'title' => $list['title'],
                    'description' => $list['description'],
                    'location' => $list['location'],
                    'status' => $list['status'],
                    'time' => $time,
                    'post_images' => ""
                );
                $items = $this->Api_model->get_post_images($list['post_id']);
                if(!empty($items)){
                    foreach ($items as $item) {
                        if($item['default_image'] == 1)
                        {
                            $order['post_images'] = base_url() . 'media/post_images/'.$item['file_path'];
                            
                        }
                    }
                }
            
                $newlist[] = $order;
            }
            if (!empty($post_list['post_list'])) {
    
                $responseData = array(
                    'status' => 'success',
                    'data'  => $newlist
                );
                return $this->response($responseData);
            } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'No Results found',
    
                );
                return $this->response($responseData);
            }
        }
    }
    public function city_list_post()
    {
        $user_data = $_GET;
        $get_data['counts_per_page'] = $user_data['counts_per_page'];
        $get_data['current_page'] = $user_data['current_page'];
        $state = $this->input->post('state_code');
        $city_list = $this->Api_model->get_cities($get_data, $state);

        foreach ($city_list['city_list'] as $list) {
            $new_list[] = $list;
        }
        if (!empty($city_list['city_list'])) {

            $responseData = array(
                'status' => 'success',
                'data'  => $new_list
            );
            return $this->response($responseData);
        } else {
            $responseData = array(
                'status' => 'error',
                'message' => 'No Results found',

            );
            return $this->response($responseData);
        }
    }
    public function state_list_get()
    {
        $user_data = $_GET;
        $get_data['counts_per_page'] = $user_data['counts_per_page'];
        $get_data['current_page'] = $user_data['current_page'];
        $state_list = $this->Api_model->get_states($get_data);

        foreach ($state_list['state_list'] as $list) {
            $new_list[] = $list;
        }
        if (!empty($state_list['state_list'])) {

            $responseData = array(
                'status' => 'success',
                'data'  => $new_list
            );
            return $this->response($responseData);
        } else {
            $responseData = array(
                'status' => 'error',
                'message' => 'No Results found',

            );
            return $this->response($responseData);
        }
    }
    public function post_search_post()
    {
        $user_data = $_GET;
            $get_data['counts_per_page'] = $user_data['counts_per_page'];
            $get_data['current_page'] = $user_data['current_page'];
            $search = array(
                'title' => $this->input->post('title'),
                'description' => $this->input->post('description'),
                'location' => $this->input->post('location'),
            );
            $orderList = $this->Api_model->get_search_post($get_data, $search);
            foreach ($orderList['post_list'] as $list) {
                $current_time = new DateTime('now');
                $datetime_obj = new DateTime($list['date_added']);
                $interval = $datetime_obj->diff($current_time);
                if ($interval->y > 0) {
                    $time = $interval->y . ' year' . ($interval->y > 1 ? 's' : '') . ' ago';
                } elseif ($interval->m > 0) {
                    $time = $interval->m . ' month' . ($interval->m > 1 ? 's' : '') . ' ago';
                } elseif ($interval->d > 0) {
                    $time = $interval->d . ' day' . ($interval->d > 1 ? 's' : '') . ' ago';
                } elseif ($interval->h > 0) {
                    $time = $interval->h . ' hour' . ($interval->h > 1 ? 's' : '') . ' ago';
                } elseif ($interval->i > 0) {
                    $time = $interval->i . ' minute' . ($interval->i > 1 ? 's' : '') . ' ago';
                } else {
                    $time = 'just now';
                }
                $order = array(
                    'post_id' => $list['post_id'],
                    'user_id' => $list['user_id'],
                    'title' => $list['title'],
                    'description' => $list['description'],
                    'location' => $list['location'],
                    'status' => $list['status'],
                    'time' => $time,
                    'post_images' => ""
                );
                $items = $this->Api_model->get_post_images($list['post_id']);
                if(!empty($items)){
                    foreach ($items as $item) {
                        if($item['default_image'] == 1)
                        {
                            $order['post_images'] = base_url() . 'media/post_images/'.$item['file_path'];
                            
                        }
                    }
                }
            
                $newlist[] = $order;
            } 
            if (!empty($orderList['post_list'])) {

                $responseData = array(
                    'status' => 'success',
                    // 'base_url' => base_url() . 'media/post_images/',
                    'data'  => $newlist
                );
                return $this->response($responseData);
            } else {
                $responseData = array(
                    'status' => 'success',
                    'message' => 'No Records found',

                );
                return $this->response($responseData);
            }
    }
    public function send_message_post()
    {
        $this->form_validation->set_rules('user_id_from', 'user id', 'required');
        $this->form_validation->set_rules('user_id_to', 'user id', 'required');
        $this->form_validation->set_rules('message', 'message', 'required');

        $this->load->helper('functions');
        $date_added = get_current_datetime();

        if ($this->form_validation->run()) {
            $data = [
                'user_id_from' => $this->post('user_id_from'),
                'user_id_to' => $this->post('user_id_to'),
                'message' => $this->post('message'),
                'status' => 1,
                'date_added' => $date_added,
                'date_updated' => $date_added

            ];

            $res = $this->db->insert('message', $data);
            if ($res) {
                $responseData = array(
                    'status' => 'success',
                    'message' => 'Message Sent',
                );
            } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Please try again',
                );
            }
            return $this->response($responseData);
        } else {
            $responseData = array(
                'status' => 'error',
                'message' => 'Validation failed please check your input field',
            );
            return $this->response($responseData);
        }
    }
    public function get_user_message_post()
    {
        //Form Validation
        $this->form_validation->set_rules('user_id', 'user id', 'required');
        if ($this->form_validation->run() == false) {
            $responseData = array(
                'status' => 'fail',
                'message' => 'Validation failed please check your input field',
            );
            return $this->response($responseData, 200);
        } else //If validation success
        {
            $user_id = $this->input->post('user_id');
            $user_list = $this->Api_model->get_user_msg($user_id);
            // print_r($user_list);
            // die;
            if(!empty($user_list))
            {
                foreach ($user_list as $list) {
                    if($list['user_id_from'] == $user_id) {
                        $id_list = $list['user_id_to'];
                    } elseif($list['user_id_to'] == $user_id) {
                        $id_list = $list['user_id_from'];
                    }
                    $new_list[] = $id_list;
                }
            } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'No Results found',

                );
                return $this->response($responseData);
            }
            $this->load->helper('array');
            $unique_array = array_unique($new_list);
            $user_data = $_GET;
            $get_data['counts_per_page'] = $user_data['counts_per_page'];
            $get_data['current_page'] = $user_data['current_page'];
            $user_msg_list = $this->Api_model->get_user_list($get_data, $unique_array);
            
            foreach ($user_msg_list['user_list'] as $ulist) {
                $new_ulist[] = $ulist;
            }
            if (!empty($user_msg_list['user_list'])) {

                $responseData = array(
                    'status' => 'success',
                    'image_url' => base_url().'media/profile_images/',
                    'data'  => $new_ulist
                );
                return $this->response($responseData);
            } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'No Results found',

                );
                return $this->response($responseData);
            }
        }
    }
    public function get_message_list_post()
    {
        //Form Validation
        $this->form_validation->set_rules('user_id_from', 'user id', 'required');
        $this->form_validation->set_rules('user_id_to', 'user id', 'required');
        if ($this->form_validation->run() == false) {
            $responseData = array(
                'status' => 'fail',
                'message' => 'Validation failed please check your input field',
            );
            return $this->response($responseData, 200);
        } else //If validation success
        {
            $user_data = $_GET;
            $get_data['counts_per_page'] = $user_data['counts_per_page'];
            $get_data['current_page'] = $user_data['current_page'];
            $user_id_from = $this->input->post('user_id_from');
            $user_id_to = $this->input->post('user_id_to');
            $msg_list = $this->Api_model->get_msg_list($get_data, $user_id_from, $user_id_to);

            foreach ($msg_list['msg_list'] as $list) {
                $new_list[] = $list;
            }
            if (!empty($msg_list['msg_list'])) {

                $responseData = array(
                    'status' => 'success',
                    'data'  => $new_list
                );
                return $this->response($responseData);
            } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'No Results found',

                );
                return $this->response($responseData);
            }
        }
    }
    public function social_login_post()
    {
        $status = 1;
        //Get Current Date and Time
        $this->load->helper('functions');
        //echo get_current_datetime();
        $date_added = get_current_datetime();
        $this->form_validation->set_rules('first_name', 'First Name', 'required');
        // $this->form_validation->set_rules('last_name', 'Last Name', 'required');
        // $this->form_validation->set_rules('email', 'Email', 'required|valid_email|is_unique[users.email]');
        // $this->form_validation->set_rules('password', 'Password', 'required');
        if ($this->form_validation->run()) {
            if ( null !== $this->input->post('email') && !empty($this->input->post('email'))) {
                $data = array('email' => $this->input->post('email'), 'status' => 1);
                $loginStatus = $this->Api_model->checkLogin($data);
                if ($loginStatus != false) {
                    $patientDate = [
                        'user_id' => $loginStatus->user_id,
                        'first_name' => $loginStatus->first_name,
                        'last_name' => $loginStatus->last_name,
                        'email' => $loginStatus->email,
                        'phone' => $loginStatus->phone,
                        'dob' => $loginStatus->dob,
                        'address' => $loginStatus->address,
                        'state' => $loginStatus->state,
                        'city' => $loginStatus->city,
                        'state_code' => $loginStatus->state_code,
                        'city_code' => $loginStatus->city_code,
                        'zipcode' => $loginStatus->zipcode,
                        'status' => $loginStatus->status,
                        'date_added' => $loginStatus->date_added,
                        'date_updated' => $loginStatus->date_updated,
                    ];
                    $responseData = array(
                        'status' => 'success',
                        'userInfo' => $patientDate,
                        //  'userInfo' => $userInfo,
                    );
                    return $this->response($responseData, 200);
                } else {
                    $input_data = array(
                        'first_name' => $this->input->post('first_name', true),
                        'last_name' => $this->input->post('last_name', true),
                        'email' => $this->input->post('email', true),
                        'status' => $status,
                        'date_added' => $date_added,
                        'date_updated' => $date_added,
                    );
                    $res = $this->User_model->insert($input_data);
                    $insert_id = $this->db->insert_id();
                    $query = $this->db->get_where('users', array('user_id' => $insert_id));
                    $row = $query->row();
                        if ($res == true) {
                            $data['success_message'] = 'User registered successfully';
                            $responseData = array(
                                'status' => 'success',
                                'message' => $data['success_message'],
                                'userInfo' => array(
                                    'user_id' => $row->user_id,
                                    'first_name' => $row->first_name,
                                    'last_name' => $row->last_name,
                                    'email' => $row->email,
                                    'phone' => $row->phone,
                                    'dob' => $row->dob,
                                    'address' => $row->address,
                                    'state' => $row->state,
                                    'city' => $row->city,
                                    'state_code' => $row->state_code,
                                    'city_code' => $row->city_code,
                                    'zipcode' => $row->zipcode,
                                    'status' => $row->status,
                                    'date_added' => $row->date_added,
                                    'date_updated' => $row->date_updated,
                                ),
                            );
                            return $this->response($responseData, 200);
                        } else {
                            $data['error_message'] = 'Unable to register, Please try again';
                            $responseData = array(
                                'status' => 'success',
                                'message' => $data['error_message'],
                            );
                            return $this->response($responseData, 200);
                        }
                    
                }
            } elseif ( null !== $this->input->post('phone') && !empty($this->input->post('phone'))) {
                $data = array('phone' => $this->input->post('phone'), 'status' => 1);
                $loginStatus = $this->Api_model->checkLogin($data);
                if ($loginStatus != false) {
                    $patientDate = [
                        'user_id' => $loginStatus->user_id,
                        'first_name' => $loginStatus->first_name,
                        'last_name' => $loginStatus->last_name,
                        'email' => $loginStatus->email,
                        'phone' => $loginStatus->phone,
                        'dob' => $loginStatus->dob,
                        'address' => $loginStatus->address,
                        'state' => $loginStatus->state,
                        'city' => $loginStatus->city,
                        'state_code' => $loginStatus->state_code,
                        'city_code' => $loginStatus->city_code,
                        'zipcode' => $loginStatus->zipcode,
                        'status' => $loginStatus->status,
                        'date_added' => $loginStatus->date_added,
                        'date_updated' => $loginStatus->date_updated,
                    ];
                    $responseData = array(
                        'status' => 'success',
                        'userInfo' => $patientDate,
                        //  'userInfo' => $userInfo,
                    );
                    return $this->response($responseData, 200);
                } else {
                    $input_data = array(
                        'first_name' => $this->input->post('first_name', true),
                        'last_name' => $this->input->post('last_name', true),
                        'phone' => $this->input->post('phone', true),
                        'status' => $status,
                        'date_added' => $date_added,
                        'date_updated' => $date_added,
                    );
                    $res = $this->User_model->insert($input_data);
                    $insert_id = $this->db->insert_id();
                    $query = $this->db->get_where('users', array('user_id' => $insert_id));
                    $row = $query->row();
                    if ($res == true) {
                        $data['success_message'] = 'User registered successfully';
                        $responseData = array(
                            'status' => 'success',
                            'message' => $data['success_message'],
                            'userInfo' => array(
                                'user_id' => $row->user_id,
                                'first_name' => $row->first_name,
                                'last_name' => $row->last_name,
                                'email' => $row->email,
                                'phone' => $row->phone,
                                'dob' => $row->dob,
                                'address' => $row->address,
                                'state' => $row->state,
                                'city' => $row->city,
                                'state_code' => $row->state_code,
                                'city_code' => $row->city_code,
                                'zipcode' => $row->zipcode,
                                'status' => $row->status,
                                'date_added' => $row->date_added,
                                'date_updated' => $row->date_updated,
                            ),
                        );
                        return $this->response($responseData, 200);
                    } else {
                        $data['error_message'] = 'Unable to register, Please try again';
                        $responseData = array(
                            'status' => 'success',
                            'message' => $data['error_message'],
                        );
                        return $this->response($responseData, 200);
                    }
                }
            } else {
                    $responseData = array(
                        'status' => 'error',
                        'message' => 'Validation failed please check your input field',
                    );
                return $this->response($responseData);
            }
        } else {
                $responseData = array(
                    'status' => 'error',
                    'message' => 'Validation failed please check your input field',
                );
            return $this->response($responseData);
        }
    }
    private function generate_token($data)
    {
        $payload = json_encode($data);
        $iv = openssl_random_pseudo_bytes(openssl_cipher_iv_length('aes-256-cbc'));
        $encrypted_payload = openssl_encrypt($payload, 'aes-256-cbc', $this->secret_key, 0, $iv);
        $encrypted_token = base64_encode($encrypted_payload) . ':' . base64_encode($iv);
        return $encrypted_token;
    }
    private function verify_token($encrypted_token)
    {
        $token_parts = explode(':', $encrypted_token);
        if (count($token_parts) != 2) {
            return false;
        }
        $encrypted_payload = base64_decode($token_parts[0]);
        $iv = base64_decode($token_parts[1]);
        $payload = openssl_decrypt($encrypted_payload, 'aes-256-cbc', $this->secret_key, 0, $iv);
        if (!$payload) {
            return false;
        }
        $data = json_decode($payload);
        if (!$data) {
            return false;
        }
        return true;
    }
}
