<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Post extends CI_Controller {

	function __construct() { 
         parent::__construct(); 
         error_reporting(0);
		 $this->load->model('Post_model');
    }
	public function index()
	{
		$this->get_listdata();
	}
	public function get_listdata()
	{
		$data['page_title'] = 'Post'; 
        $data['materials'] = $this->Post_model->get_all_materials();
        $data['users'] = $this->Post_model->get_all_users();
        
	    $this->load->view('admin/post_view',$data);
	}
	public function getdata($id)
	{
		$result = $this->Post_model->get_data($id); 
		echo json_encode($result);
	}
	public function add() { 
		$edit_id = $this->input->post('edit_id', TRUE);
		//echo "<br>ID:$edit_id";
		//Redirect if NAN
		if (!is_numeric($edit_id)) 
			$this->get_listdata();
		//Form Validation 
		$this->form_validation->set_rules('title', 'Title', 'required');
		$this->form_validation->set_rules('description', 'Description', 'required');
		$this->form_validation->set_rules('material_type', 'Material type', 'required');
		$this->form_validation->set_rules('user', 'User', 'required');
		$this->form_validation->set_rules('location', 'Location', 'required');

		if ($this->form_validation->run() == FALSE)
		{
			//echo "<br>Validation Not Success";
			//redirect('master/'.$type);
			$this->get_listdata();
		} else //If validation success
		{

			//Get Current Date and Time
			$this->load->helper('functions');
			$date_added = get_current_datetime();

			if($edit_id==0) //Add
			{
				$input_data = array( 
					'title' => $this->input->post('title', TRUE),
				    'description' => $this->input->post('description', TRUE),
				    'material_type' => $this->input->post('material_type', TRUE),
				    'user_id' => $this->input->post('user', TRUE),
				    'location' => $this->input->post('location', TRUE),
				 	'status' => 1,
					'date_added' => $date_added,
					'date_updated' => $date_added,
				); 
				$res = $this->Post_model->insert($input_data); 
				if($res==true){
                    $data['success_message'] = 'Record added successfully';
                    $this->session->set_userdata('display_message', $data);
                } else {
                    $data['error_message'] = 'Something went wrong';
                    $this->session->set_userdata('display_message', $data);
                }
			
			}
			else //Edit
			{
				$input_data = array(
                    'title' => $this->input->post('title', TRUE),
                    'description' => $this->input->post('description', TRUE),
                    'material_type' => $this->input->post('material_type', TRUE),
                    'user_id' => $this->input->post('user', TRUE),
                    'location' => $this->input->post('location', TRUE),
                    'status' => 1,
                    'date_updated' => $date_added,
                );
            }
            $res = $this->Post_model->update($input_data,$edit_id);
            if($res==true){
                $data['success_message'] = 'Record updated successfully';
                $this->session->set_userdata('display_message', $data);
            } else {
                $data['error_message'] = 'Something went wrong';
                $this->session->set_userdata('display_message', $data);
            }
            redirect('post');
		}
	}
 
		 
	public function delete($id)
	{
		 $res = $this->Post_model->delete($id); 
		 if($res)
		 {
			 $data['success_message'] = 'Record delete successfully';
			 $this->session->set_userdata('display_message', $data);
		 }
		 else
		 {
			 $data['error_message'] = 'Something went wrong';
			 $this->session->set_userdata('display_message', $data);
		 }
		redirect('post');
		 
	}
	 
	
	public function setstatus()
	{
		$id = $this->input->post('id');
		$current_st = $this->input->post('current_st');
		if($current_st == 1) {
			$statusData = array('status' => 0);
		} else {
			$statusData = array('status' => 1);
		}
		$update = $this->Post_model->update_status($id, $statusData);
		if($update==true)
		{
			echo 1;
		}else{
			echo 0;
		}
	}
	
	public function get_list()
	{

		$list = $this->Post_model->get_datatables(); 
		// print_r($list); 
		$data = array();
		$no = $_POST['start'];
		foreach ($list as $r) {
			$primary_id = $r->post_id;
			// print_r($primary_id); die();
			$no++;
			$row = array();
			$row[] = '<input type="checkbox" name="chk[]" id="chk_'.$primary_id.'" value="'.$primary_id.'" />';
			// $row[] = $no;
 			$row[] = $r->title;
 			$row[] = $r->description;
 			$row[] = $r->material_name;
 			$row[] = $r->location;

			if($r->status==1)
			{
				$status = "<label class='label label-success'>Active</label>";
			}else{
				$status = "<label class='label label-danger'>Inactive</label>";
			}
			// if($r->date_updated=='0000-00-00 00:00:00'){
            //     $row[] = '';
            // }else{
            //     $row[] = $r->date_updated;
            // }
			$row[] = '<h4>'.$status.'</h4>';
			// $row[] = '
			// 		<span class="mytooltip">                 
			// 		<a href="javascript:void(0)" onClick="doEdit('. $primary_id.');" class="btn btn-dark btn-xs" data-toggle="modal" data-target="#model_add"> <i class="fa fa-pencil"></i></a>
			// 		<span class="tooltiptext">Edit</span>
			// 		</span>
			// 		<span class="mytooltip" >                     
			// 		<a href="javascript:void(0)" onClick="DeleteSet('.$primary_id.');" class="btn btn-danger btn-xs" data-toggle="modal" data-target="#model_delete"> <i class="fa fa-trash-o"></i></a>
			// 		<span class="tooltiptext">Delete</span>
			// 		</span>
			// 		<span class="mytooltip" >                     
			// 		<a href="javascript:void(0)" onClick="ModelImages('.$primary_id.');" class="btn btn-primary btn-xs"> <i class="fa fa-plus"></i></a>
			// 		<span class="tooltiptext">Add&nbsp;Media</span>
			// 		</span>
			// 		';
			$row[] = '<span class="mytooltip" >                     
					<a href="javascript:void(0)" onClick="ModelImages(' . $primary_id . ');" class="btn btn-primary btn-xs"> <i class="fa fa-plus"></i></a>
					<span class="tooltiptext">View&nbsp;Images</span>
					</span>
					<span class="mytooltip" >                     
					<a href="javascript:void(0)" onClick="DeleteSet(' . $primary_id . ');" class="btn btn-danger btn-xs" data-toggle="modal" data-target="#model_delete"> <i class="fa fa-trash-o"></i></a>
					<span class="tooltiptext">Delete</span>
					</span>
					';
			$data[] = $row;
			
		}
		$output = array(
						"draw" => $_POST['draw'],
						"recordsTotal" => $this->Post_model->count_all(),
						"recordsFiltered" => $this->Post_model->count_filtered(),
						"data" => $data
				);
		//output to json format
		echo json_encode($output);
	}
		  
}
?>