<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class User_log extends CI_Controller {

	function __construct() { 
         parent::__construct(); 
		 //$this->load->model('admin_user_model');	
		 $this->load->model('user_log_model');
    } 

	public function index()
	{
		$this->get_listdata();
	}
	
	public function get_listdata()
	{
		$data['page_title'] = 'Manage User Log';
		$data['records'] =$this->user_log_model->get_list(); 
		//$data['records'] =$this->admin_user_model->get_list(); 
		$this->load->view('admin/user_log_view',$data);
	}

	public function getdata($id)
	{
		 $result = $this->admin_user_model->get_data($id); 
		 echo json_encode($result);
	}
	public function get_userlog($id)
	{
		 $result = $this->user_log_model->get_userlog($id); 
		 echo json_encode($result);
	}
	
	public function add() { 
		$edit_id = $this->input->post('edit_id', TRUE);
		//echo "<br>ID:$edit_id";
		
		//Redirect if NAN
		if (!is_numeric($edit_id)) $this->get_listdata();
		
		//Form Validation 
		if ($edit_id==0) 
		//$this->form_validation->set_rules('username', 'Username', 'required|is_unique[user_log.username]',array('is_unique' => '%s is already registered.'));
		
		if ($this->form_validation->run() == FALSE)
		{
			//echo "<br>Validation Not Success";
			$this->get_listdata();
		}
		else //If validation success
		{
			//echo "<br>Validation Success";
			 $status =$this->input->post('status');
			 if(empty($status) || $status == NULL || $status == "") $status = 0;
			 else $status = 1;

			//Get Current Date and Time
			$this->load->helper('functions');
			//echo get_current_datetime();
			$date_added = get_current_datetime();
			if($edit_id==0) //Add
			{
				$input_data = array( 
					
					'login_datetime' => $this->input->post('login_datetime', TRUE),
					'user_ip' => md5($this->input->post('user_ip', TRUE)),
					'user_type' => $this->input->post('user_type', TRUE),
					'status' => $status,
					'date_added' => $date_added,
					'admin_user_id' => $this->input->post('admin_user_id', TRUE),
				); 
				$res = $this->user_log_model->insert($input_data); 
				$data['success_message'] = 'Record added successfully';
				$data['error_message'] = '';
			}
			 //$this->get_listdata();
			 $this->session->set_userdata('display_message', $data);
			 if($this->input->post('isProfile', TRUE)==1) redirect('user_log/profile/'.$edit_id);
			 else redirect('user_log');
			}
		  } 
		 
	public function delete($id)
	{
		 $res = $this->user_log_model->delete($id); 
		 if($res)
		 {
			 $data['success_message'] = 'Record delete successfully';
			 $this->session->set_userdata('display_message', $data);
		 }
		 else
		 {
			 $data['error_message'] = 'You can not delete this record. because you logged in with this user';
			 $this->session->set_userdata('display_message', $data);
		 }
		redirect('user_log');
		 
	}
	public function deleteall()
	{
		 $ids = $this->input->post('ids', TRUE);
		 $ids = substr($ids, 0, -1);
		 $res = $this->user_log_model->deleteall($ids); 
		 if($res)
		 {
			 $data['success_message'] = 'Record delete successfully';
			 $this->session->set_userdata('display_message', $data);
		 }
		 else
		 {
			 $data['error_message'] = 'You can not delete this record. because you logged in with this user';
			 $this->session->set_userdata('display_message', $data);
		 }
			 redirect('user_log');
		 
	}
	
	public function setstatus()
	{
		$id = $this->input->post('id');
		$current_st = $this->input->post('current_st');
		if($current_st == 1) {
			$statusData = array('status' => 0);
		} else {
			$statusData = array('status' => 1);
		}
		$this->user_log_model->update_status($id, $statusData);
	}
	
	public function profile($id)
	{
		$data['page_title'] = 'My Profile';
		$data['records'] = $this->user_log_model->get_data($id); 
		$data['upload_error'] = '';
		$this->load->view('profile_view',$data);
	}
	
	public function editprofile() { 
		$edit_id = $this->input->post('edit_id', TRUE);
		//echo "<br>ID:$edit_id";
		
		//Redirect if NAN
		if (!is_numeric($edit_id)) $this->get_listdata();
		
		//Form Validation 
					
				
		$this->form_validation->set_rules('full_name', 'Full Name', 'required');
		if ($edit_id==0) $this->form_validation->set_rules('email', 'Email', 'required|is_unique[user_log.email]',array('is_unique' => '%s is already registered.'));
		else $this->form_validation->set_rules('email', 'Email', 'required');
		
		if ($this->form_validation->run() == FALSE)
		{
			//echo "<br>Validation Not Success";
			//$this->get_listdata();
			
		}
		else //If validation success
		{
			//echo "<br>Validation Success";
			 $status =$this->input->post('status');
			 if(empty($status) || $status == NULL || $status == "") $status = 0;
			 else $status = 1;

			//Get Current Date and Time
			$this->load->helper('functions');
			//echo get_current_datetime();
			$date_added = get_current_datetime();
			
			$dob = $this->input->post('dob', TRUE);
			if($dob != "") $dob = get_onlydate_sql_format($dob);
			
			if($edit_id>0) //Add
			{
				
				$input_data = array( 
					'full_name' => $this->input->post('full_name', TRUE),
					'email' => $this->input->post('email', TRUE),
					'mobile' => $this->input->post('mobile', TRUE),
					'address' => $this->input->post('address', TRUE), 
					'dob' => $dob,
					'date_updated' => $date_added
				);
				$res = $this->user_log_model->update($input_data,$edit_id);
				$data['success_message'] = 'Record updated successfully';
				$data['error_message'] = '';
			}
			 //$this->get_listdata();
			 $this->session->set_userdata('display_message', $data);
			 redirect('user_log/profile/'.$edit_id);
			 
			}
		  } 
		 
	public function upload_image($user_id) 
	{
		$data['page_title'] = "My Profile";
		$data['records'] = $this->user_log_model->get_data($user_id); 
		
		$this->load->library('upload');
		
		if(!is_dir('./media/users')){
			echo "here not";
			mkdir('./media/users');
		}
		else echo "here yes ";
		$uploadPath = 'media/users/';
		
		$config['upload_path'] = $uploadPath;
		$config['allowed_types'] = 'gif|jpg|jpeg|png';
		$config['max_size'] = '5120';
		$config['encrypt_name'] = TRUE;
		$this->upload->initialize($config);
		echo " here1";
		if (!$this->upload->do_upload('userfile')) {
			echo "here2";
			$data['upload_error'] = $this->upload->display_errors();
			$this->load->view('profile_view', $data);
		} else {
		echo "here3";
			$user = $this->user_log_model->get_data($user_id);
			$image = $user->profile_image;
			if($image) {
				unlink($image);
			}
			
			$imageData = $this->upload->data();
			$imagePath = $imageData['file_name'];
		
			$usersData = array(
				'profile_image' => $imagePath
			);
			
			$this->user_log_model->update($usersData,$user_id);
			redirect('user_log/profile/'.$user_id);
		}
	}

	function changepw($id)
	{
		$data['page_title'] = 'My Profile - Change Password';
		$this->load->view('changepw_view', $data);
	}


	public function update_pw($id) { 
		
		//Form Validation 
		$this->form_validation->set_rules('password', 'Password', 'required');

		if ($this->form_validation->run() == FALSE)
		{
			//echo "<br>Validation Not Success";
			$this->changepw($id);
		}
		else //If validation success
		{
			//echo "<br>Validation Success";
				$input_data = array( 
					'password' => md5($this->input->post('password', TRUE)),
				);
				$res = $this->user_log_model->update($input_data,$id);
				$data['success_message'] = 'Password changed successfully';
				$data['error_message'] = '';
			 //$this->get_listdata();
			 $this->session->set_userdata('display_message', $data);
			 $this->changepw($id);
		}
	}
	
}
?>