<?php
//session_start();
Class Admin_user_model extends CI_Model
{
	
	var $table = 'admin_user';
	//var $table2 = 'customer_family';
	var $column_order = array('','','username','full_name','email','mobile','user_type','status','date_added','date_updated','status'); //set column field database for datatable orderable
	var $column_search = array('full_name','username','email','mobile','user_type','status','date_added','date_updated'); //set column field database for datatable searchable 
//	var $order = array('full_name' => 'asc'); // default order 
	
  function __construct() { 
	 parent::__construct(); 
  } 
	
	public function get_list() {
		$this->db->select('*');
		$this->db->from('admin_user');
		$query = $this->db->get();
		return $query->result();
	}
	
	public function get_data($id) {
		$this->db->select('*');
		$this->db->from('admin_user');
		$this->db->where('admin_user_id', $id);
		$query = $this->db->get();
		if($query->num_rows() > 0) {
			return $query->row();
		}
	}
	public function insert($data) { 
	    //echo "<br> Insert";
		 
		if ($this->db->insert("admin_user", $data)) { 
			return true; 
		} 
	} 
	
	public function update($data,$id) { 
		$this->db->set($data); 
		$this->db->where("admin_user_id", $id); 
		
		if ( $this->db->update("admin_user", $data)) {  
		 return true; 
		}
	} 
	
	public function delete($id) { 
		 //Cant delete self 
		// echo $id; die();
		 if($id == $this->session->userdata['logged_in']['admin_user_id']) return false;
		 
		 if ($this->db->delete("admin_user", "admin_user_id = ".$id)) { 
			return true; 
		 } 
	} 

	public function update_status($id, $statusData) {
		//Cant delete self 
		 if($id == $this->session->userdata['logged_in']['admin_user_id']) return 2;
		$this->db->where('admin_user_id', $id);
		$update = $this->db->update('admin_user', $statusData);
		return ($update==true)?1 :0; 
	}
	
	private function _get_datatables_query()
	{
		$admin_user_id = $this->session->userdata['logged_in']['admin_user_id'];
		$this->db->select('*');
		$this->db->where("user_type", 'user'); 
		$this->db->from('admin_user');
		$i = 0;
	
		foreach ($this->column_search as $item) // loop column 
		{
			if($_POST['search']['value']) // if datatable send POST for search
			{
				
				if($i===0) // first loop
				{
					$this->db->group_start(); // open bracket. query Where with OR clause better with bracket. because maybe can combine with other WHERE with AND.
					$this->db->like($item, $_POST['search']['value']);
				}
				else
				{
					$this->db->or_like($item, $_POST['search']['value']);
				}
				if(count($this->column_search) - 1 == $i) //last loop
					$this->db->group_end(); //close bracket
			}
			$i++;
		}
		
		if(isset($_POST['order'])) // here order processing
		{
			$this->db->order_by($this->column_order[$_POST['order']['0']['column']], $_POST['order']['0']['dir']);
		} 
		else if(isset($this->order))
		{
			$order = $this->order;
			$this->db->order_by(key($order), $order[key($order)]);
		}
	}
	public function get_datatables()
	{
		$this->_get_datatables_query();
		if($_POST['length'] != -1)
		$this->db->limit($_POST['length'], $_POST['start']);
		
		$query = $this->db->get();
		//echo "SQL:" . $this->db->last_query();
		return $query->result();
	}
	public function count_filtered()
	{
		$this->_get_datatables_query();
		$query = $this->db->get();
		return $query->num_rows();
	}
	public function count_all()
	{
		$this->db->from($this->table);
		return $this->db->count_all_results();
	}

}
?>