<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

class Api_model extends CI_Model
{

  public function __construct()
  {
    parent::__construct();
    $this->load->database();
  }
  // ########login data Start-#####
  public function checkLogin($data)
  {
    $this->db->where($data);
    $query = $this->db->get('users');
    
    if ($query->num_rows() == 1) {
      return $query->row();
    } else {
      return false;
    }
  }
  //#########-login data--end-##########

  public function change_password($data)
  {
    $this->db->where($data);
    $query = $this->db->get('users');
    if ($query->num_rows() == 1) {
      return $query->row();
    } else {
      return false;
    }
  }

  public function update_password($user_id, $data)
  {
    $this->db->set($data);
    $this->db->where("user_id", $user_id);

    if ($this->db->update("users", $data)) {
      return true;
    } else {
      return false;
    }
  }

  // ################ Forgot Password start ##############

  public function checkForgotPW($data)
  {
    $this->db->where($data);
    $query = $this->db->get('users');
    if ($query->num_rows() == 1) {
      return $query->row();
    } else {
      return false;
    }
  }
  // ################ Forgot Password end ###############



  public function delete_account($id) { 
    $data = array('status' => 0); // Set the new value for the status column
    $this->db->where("user_id", $id); 
    if ($this->db->update("users", $data)) {  
        return true; 
    } else {
        return false;
    }
}

  public function insert_contact($data) { 
    //echo "<br> Insert";
    if ($this->db->insert("contact_us", $data)) { 
    return true; 
    }else{
    return false;
    }
} 

  public function get_post($inputs, $search)
  {
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $offset = ($inputs['current_page'] > 1) ? (($inputs['current_page'] - 1) * $inputs['counts_per_page']) : 0;
    }
    $likeCondition = '';
    if (isset($search['search_text']) && !empty($search['search_text'])) {
      $search_text = $search['search_text'];
      $likeCondition .= "(p.title LIKE '%$search_text%') OR ";
      $likeCondition .= "(p.description LIKE '%$search_text%') OR ";
      $likeCondition .= "(p.location LIKE '%$search_text%') OR ";
      $likeCondition .= "(p.material_name LIKE '%$search_text%') OR ";
    }
    if (isset($search['location']) && !empty($search['location'])) {
      $location = $search['location'];
      $likeCondition .= "(p.location LIKE '%$location%') OR ";
    }
    if (isset($search['material_type']) && !empty($search['material_type'])) {
      $material_type = $search['material_type'];
      $material_types_str = "'" . implode("', '", $material_type) . "'";
      $likeCondition .= "(p.material_type IN ($material_types_str)) OR ";
    }
    $likeCondition = rtrim($likeCondition, " OR ");

    $oredrs = $this->db->count_all_results('post', FALSE, FALSE, $likeCondition);
    $this->db->distinct('p.post_id');
    $this->db->select('p.*, m.material_name, u.first_name, u.last_name');
    $this->db->from('post as p');
    $this->db->where('p.status', 1);

		if(!empty($search['search_text'])){
			$this->db->like('p.title', $search['search_text']); 
			$this->db->or_like('p.description', $search['search_text']); 
			$this->db->or_like('p.location', $search['search_text']); 
			$this->db->or_like('p.material_name', $search['search_text']); 
		}
    if(!empty($search['location'])){
			$this->db->like('p.location', $search['location']); 
		}
    if(!empty($search['material_type'])){
			$this->db->where_in('p.material_type', $search['material_type']);
		}

    $this->db->join('material as m', 'm.material_id = p.material_type', 'left');
    $this->db->join('users as u', 'u.user_id = p.user_id', 'left');
    $this->db->order_by('p.date_added', 'DESC');
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $this->db->limit($inputs['counts_per_page'], $offset);
    }

    $result = $this->db->get()->result_array();
    $count = $oredrs;
    $total_pages = 0;
    $next_page = -1;
    $page = $inputs['current_page'];
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      if ($count > 0 && $page > 0) {
        $total_pages = ceil($count / $inputs['counts_per_page']);
        $page = $inputs['current_page'];
        if ($page < $total_pages) {
          $next_page = ($page + 1);
        } else {
          $next_page = -1;
        }
        $new_details['next_page'] = $next_page;
        $new_details['current_page'] = $page;
        $new_details['total_pages'] = $total_pages;
        $new_details['post_list'] = $result;
      }
    } else {
      $new_details['post_list'] = $result;
    }
    return $new_details;
  }

  public function get_post_images($id)
  {
    $this->db->select('*');
		$this->db->from('post_image');
		$this->db->where('post_id', $id);
    $this->db->where('status', 1);
		$query = $this->db->get();
		return $query->result_array();
  }
  public function get_materials($inputs)
  {
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $offset = ($inputs['current_page'] > 1) ? (($inputs['current_page'] - 1) * $inputs['counts_per_page']) : 0;
    }
    $materials = $this->db->count_all_results('material');
    $this->db->select('*');
    $this->db->from('material');

    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $this->db->limit($inputs['counts_per_page'], $offset);
    }
    $result = $this->db->get()->result_array();
    $count = $materials;
    $total_pages = 0;
    $next_page = -1;
    $page = $inputs['current_page'];
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      if ($count > 0 && $page > 0) {
        $total_pages = ceil($count / $inputs['counts_per_page']);
        $page = $inputs['current_page'];
        if ($page < $total_pages) {
          $next_page = ($page + 1);
        } else {
          $next_page = -1;
        }
        $new_details['next_page'] = $next_page;
        $new_details['current_page'] = $page;
        $new_details['total_pages'] = $total_pages;
        $new_details['material_list'] = $result;
      }
    } else {
      $new_details['material_list'] = $result;
    }
    return $new_details;
  }
  public function load_profile_data($user_id)
  {

    $this->db->select('u.user_id,u.first_name,u.last_name,u.phone,u.dob,u.email,u.address,u.state,u.city,u.state_code,u.city_code,u.zipcode,u.status,u.profile_image,u.date_added,u.date_updated');
    $this->db->from('users as u');
    $this->db->where('user_id', $user_id);
    return $this->db->get()->result_array();
  }
  public function my_post_data($inputs, $data)
  {
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $offset = ($inputs['current_page'] > 1) ? (($inputs['current_page'] - 1) * $inputs['counts_per_page']) : 0;
    }
    $posts = $this->db->where($data)->count_all_results('post');
    $this->db->select('*');
    $this->db->from('post');
    $this->db->where($data);
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $this->db->limit($inputs['counts_per_page'], $offset);
    }
    $result = $this->db->get()->result_array();
    $count = $posts;
    $total_pages = 0;
    $next_page = -1;
    $page = $inputs['current_page'];
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      if ($count > 0 && $page > 0) {
        $total_pages = ceil($count / $inputs['counts_per_page']);
        $page = $inputs['current_page'];
        if ($page < $total_pages) {
          $next_page = ($page + 1);
        } else {
          $next_page = -1;
        }
        $new_details['next_page'] = $next_page;
        $new_details['current_page'] = $page;
        $new_details['total_pages'] = $total_pages;
        $new_details['post_list'] = $result;
      }
    } else {
      $new_details['post_list'] = $result;
    }
    return $new_details;
  }
  public function favouritelist_data($inputs, $data)
  {
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $offset = ($inputs['current_page'] > 1) ? (($inputs['current_page'] - 1) * $inputs['counts_per_page']) : 0;
    }
    $posts = $this->db->where('user_id',$data)->count_all_results('my_favourite');
    $this->db->select('m.date_updated as time, p.*');
    $this->db->from('my_favourite as m');
    $this->db->where('m.user_id', $data);
    $this->db->where('m.status', 1);
    $this->db->join('post as p', 'p.post_id = m.post_id', 'left');
    $this->db->order_by('m.date_updated', 'DESC');
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $this->db->limit($inputs['counts_per_page'], $offset);
    }
    $result = $this->db->get()->result_array();
    $count = $posts;
    $total_pages = 0;
    $next_page = -1;
    $page = $inputs['current_page'];
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      if ($count > 0 && $page > 0) {
        $total_pages = ceil($count / $inputs['counts_per_page']);
        $page = $inputs['current_page'];
        if ($page < $total_pages) {
          $next_page = ($page + 1);
        } else {
          $next_page = -1;
        }
        $new_details['next_page'] = $next_page;
        $new_details['current_page'] = $page;
        $new_details['total_pages'] = $total_pages;
        $new_details['post_list'] = $result;
      }
    } else {
      $new_details['post_list'] = $result;
    }
    return $new_details;
  }
  public function get_post_details($post_id)
  {
    $this->db->select('post.*');
		$this->db->from('post');
		$this->db->where('post_id', $post_id);
    $this->db->where('post.status', 1);
    // $this->db->join('material', 'material.material_id = post.material_type', 'left');
		$query = $this->db->get();
		return $query->row_array();
  }
  public function get_cities($inputs, $state)
  {
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $offset = ($inputs['current_page'] > 1) ? (($inputs['current_page'] - 1) * $inputs['counts_per_page']) : 0;
    }
    $cities = $this->db->where('state_code', $state)->count_all_results('cities');
    $this->db->select('*');
    $this->db->from('cities');
    $this->db->where('state_code', $state);

    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $this->db->limit($inputs['counts_per_page'], $offset);
    }
    $result = $this->db->get()->result_array();
    $count = $cities;
    $total_pages = 0;
    $next_page = -1;
    $page = $inputs['current_page'];
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      if ($count > 0 && $page > 0) {
        $total_pages = ceil($count / $inputs['counts_per_page']);
        $page = $inputs['current_page'];
        if ($page < $total_pages) {
          $next_page = ($page + 1);
        } else {
          $next_page = -1;
        }
        $new_details['next_page'] = $next_page;
        $new_details['current_page'] = $page;
        $new_details['total_pages'] = $total_pages;
        $new_details['city_list'] = $result;
      }
    } else {
      $new_details['city_list'] = $result;
    }
    return $new_details;
  }
  public function get_states($inputs)
  {
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $offset = ($inputs['current_page'] > 1) ? (($inputs['current_page'] - 1) * $inputs['counts_per_page']) : 0;
    }
    $states = $this->db->count_all_results('states');
    $this->db->select('*');
    $this->db->from('states');

    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $this->db->limit($inputs['counts_per_page'], $offset);
    }
    $result = $this->db->get()->result_array();
    $count = $states;
    $total_pages = 0;
    $next_page = -1;
    $page = $inputs['current_page'];
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      if ($count > 0 && $page > 0) {
        $total_pages = ceil($count / $inputs['counts_per_page']);
        $page = $inputs['current_page'];
        if ($page < $total_pages) {
          $next_page = ($page + 1);
        } else {
          $next_page = -1;
        }
        $new_details['next_page'] = $next_page;
        $new_details['current_page'] = $page;
        $new_details['total_pages'] = $total_pages;
        $new_details['state_list'] = $result;
      }
    } else {
      $new_details['state_list'] = $result;
    }
    return $new_details;
  }
  public function get_search_post($inputs, $search)
  {
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $offset = ($inputs['current_page'] > 1) ? (($inputs['current_page'] - 1) * $inputs['counts_per_page']) : 0;
    }
    $likeCondition = '';
    if (isset($search['title']) && !empty($search['title'])) {
      $title = $search['title'];
      $likeCondition .= "(title LIKE '%$title%') OR ";
    }

    if (isset($search['description']) && !empty($search['description'])) {
      $description = $search['description'];
      $likeCondition .= "(description LIKE '%$description%') OR ";
    }

    if (isset($search['city']) && !empty($search['city'])) {
      $city = $search['city'];
      $likeCondition .= "(city LIKE '%$city%') OR ";
    }

    if (isset($search['state']) && !empty($search['state'])) {
      $state = $search['state'];
      $likeCondition .= "(state LIKE '%$state%') OR ";
    }

    if (isset($search['location']) && !empty($search['location'])) {
      $location = $search['location'];
      $likeCondition .= "(location LIKE '%$location%') OR ";
    }

    if (isset($search['zipcode']) && !empty($search['zipcode'])) {
      $zipcode = $search['zipcode'];
      $likeCondition .= "(zipcode LIKE '%$zipcode%') OR ";
    }

    $likeCondition = rtrim($likeCondition, " OR ");

    $oredrs = $this->db->count_all_results('post', FALSE, FALSE, $likeCondition);
    $this->db->distinct('p.post_id');
    $this->db->select('p.*, m.material_name');
    $this->db->from('post as p');
    $this->db->where('p.status', 1);

		if(!empty($search['title'])){
			$this->db->like('p.title', $search['title']); 
		}
    if(!empty($search['description'])){
			$this->db->like('p.description', $search['description']); 
		}
		if(!empty($search['state'])){
			$this->db->like('p.state', $search['state']); 
		}
    if(!empty($search['location'])){
			$this->db->like('p.location', $search['location']); 
		}
		if(!empty($search['city'])){
			$this->db->like('p.city', $search['city']); 
		}
		if(!empty($search['zipcode'])){
			$this->db->like('p.zipcode', $search['zipcode']); 
		}

    $this->db->join('material as m', 'm.material_id = p.material_type', 'left');
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $this->db->limit($inputs['counts_per_page'], $offset);
    }
    $result = $this->db->get()->result_array();
    // return $this->db->last_query();
    $count = $oredrs;
    $total_pages = 0;
    $next_page = -1;
    $page = $inputs['current_page'];
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      if ($count > 0 && $page > 0) {
        $total_pages = ceil($count / $inputs['counts_per_page']);
        $page = $inputs['current_page'];
        if ($page < $total_pages) {
          $next_page = ($page + 1);
        } else {
          $next_page = -1;
        }
        $new_details['next_page'] = $next_page;
        $new_details['current_page'] = $page;
        $new_details['total_pages'] = $total_pages;
        $new_details['post_list'] = $result;
      }
    } else {
      $new_details['post_list'] = $result;
    }
    return $new_details;
  }
  public function is_fav($data)
  {
    $this->db->where($data);
    $query = $this->db->get('my_favourite');
    
    if ($query->num_rows() == 1) {
      return $query->row();
    } else {
      return false;
    }
  }
  public function get_msg_list($inputs, $user_id_from, $user_id_to)
  {
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $offset = ($inputs['current_page'] > 1) ? (($inputs['current_page'] - 1) * $inputs['counts_per_page']) : 0;
    }
    $where = "(`user_id_from` = $user_id_from AND `user_id_to` = $user_id_to) OR (`user_id_from` = $user_id_to AND `user_id_to` = $user_id_from)";
    $messages = $this->db->where($where)->count_all_results('message');
    $this->db->select('*');
    $this->db->from('message');
    $this->db->where('(user_id_from = ' . $user_id_from . ' AND user_id_to = ' . $user_id_to . ') OR (user_id_from = ' . $user_id_to . ' AND user_id_to = ' . $user_id_from . ')');
    $this->db->order_by('date_added', 'ASC');

    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $this->db->limit($inputs['counts_per_page'], $offset);
    }
    $result = $this->db->get()->result_array();
    $count = $messages;
    $total_pages = 0;
    $next_page = -1;
    $page = $inputs['current_page'];
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      if ($count > 0 && $page > 0) {
        $total_pages = ceil($count / $inputs['counts_per_page']);
        $page = $inputs['current_page'];
        if ($page < $total_pages) {
          $next_page = ($page + 1);
        } else {
          $next_page = -1;
        }
        $new_details['next_page'] = $next_page;
        $new_details['current_page'] = $page;
        $new_details['total_pages'] = $total_pages;
        $new_details['msg_list'] = $result;
      }
    } else {
      $new_details['msg_list'] = $result;
    }
    return $new_details;
  }
  public function get_user_msg($user_id)
  {
    $messages = $this->db->where('user_id_from', $user_id)->count_all_results('message');
    $this->db->select('*');
    $this->db->from('message');
    $this->db->where('(user_id_from = ' . $user_id . ' OR user_id_to = ' . $user_id . ')');
    $this->db->order_by('date_added', 'DESC');

    $result = $this->db->get()->result_array();
    return $result;
  }
  public function get_user_list($inputs, $unique_array)
  {
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $offset = ($inputs['current_page'] > 1) ? (($inputs['current_page'] - 1) * $inputs['counts_per_page']) : 0;
    }
    $users = $this->db->where_in('user_id', $unique_array)->count_all_results('users');
    $this->db->select('user_id, first_name, last_name, profile_image');
    $this->db->from('users');
    $this->db->where_in('user_id', $unique_array);

    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      $this->db->limit($inputs['counts_per_page'], $offset);
    }
    $result = $this->db->get()->result_array();
    $count = $users;
    $total_pages = 0;
    $next_page = -1;
    $page = $inputs['current_page'];
    if (!empty($inputs['current_page']) && !empty($inputs['counts_per_page'])) {
      if ($count > 0 && $page > 0) {
        $total_pages = ceil($count / $inputs['counts_per_page']);
        $page = $inputs['current_page'];
        if ($page < $total_pages) {
          $next_page = ($page + 1);
        } else {
          $next_page = -1;
        }
        $new_details['next_page'] = $next_page;
        $new_details['current_page'] = $page;
        $new_details['total_pages'] = $total_pages;
        $new_details['user_list'] = $result;
      }
    } else {
      $new_details['user_list'] = $result;
    }
    return $new_details;
  }
}