<?php
//session_start();
Class Plan_master_model extends CI_Model
{
	var $table = 'plan_master';
	//var $table2 = 'customer_family';
	var $column_order = array('','title','description','price','duration','status','date_updated' ); //set column field database for datatable orderable
	var $column_search = array('title','description','price','duration','status','date_updated'); 
	//set column field database for datatable searchable 
	//	var $order = array('full_name' => 'asc'); // default order 
	
  	function __construct() { 
	 	parent::__construct(); 
  	} 
	
	public function get_data($id) {
		$this->db->select('*');
		$this->db->from('plan_master as a');
		$this->db->where('plan_master_id', $id);
		$query = $this->db->get();
		return $query->row();
	}
	
	public function get_list()
	{
		$this->db->select('*');
		$this->db->from('plan_master');
		$query = $this->db->get();
		return $query->result();
	}
	
	public function insert($data) { 
	    //echo "<br> Insert";
		 
		if ($this->db->insert("plan_master", $data)) { 
			return true; 
		}else{
		 	return false;
		}
	} 
	
	public function update($data,$id) { 
		$this->db->set($data); 
		$this->db->where("plan_master_id", $id); 
		
		if ( $this->db->update("plan_master", $data)) {  
		 return true; 
		}else{
		 return false;
		}
	} 
	
	public function delete($id) { 
		$this->db->where('plan_master_id', $id);
		if ($this->db->delete("plan_master")) { 
			return true; 
		}else{
			 return false;
		}
	} 

	public function update_status($id, $statusData) {
		$arrIds = explode(",",$id);
		$this->db->where_in('plan_master_id', $arrIds);
		$update = $this->db->update('plan_master', $statusData);
		return ($update==true)?true:false;
	}
	
	private function _get_datatables_query()
	{
		$this->db->select('*');
		$this->db->from('plan_master');
		$i = 0;
	
		foreach ($this->column_search as $item) // loop column 
		{
			if($_POST['search']['value']) // if datatable send POST for search
			{
				
				if($i===0) // first loop
				{
					$this->db->group_start(); // open bracket. query Where with OR clause better with bracket. because maybe can combine with other WHERE with AND.
					$this->db->like($item, $_POST['search']['value']);
				}
				else
				{
					$this->db->or_like($item, $_POST['search']['value']);
				}
				if(count($this->column_search) - 1 == $i) //last loop
					$this->db->group_end(); //close bracket
			}
			$i++;
		}
		
		if(isset($_POST['order'])) // here order processing
		{
			$this->db->order_by($this->column_order[$_POST['order']['0']['column']], $_POST['order']['0']['dir']);
		} 
		else if(isset($this->order))
		{
			$order = $this->order;
			$this->db->order_by(key($order), $order[key($order)]);
		}
	}
	public function get_datatables()
	{
		$this->_get_datatables_query();
		if($_POST['length'] != -1)
		$this->db->limit($_POST['length'], $_POST['start']);
		
		$query = $this->db->get();
		//echo "SQL:" . $this->db->last_query();
		return $query->result();
	}
	public function count_filtered()
	{
		$this->_get_datatables_query();
		$query = $this->db->get();
		return $query->num_rows();
	}
	public function count_all()
	{
		$this->db->from($this->table);
		return $this->db->count_all_results();
	}

}
?>