<?php
//session_start();
Class Post_model extends CI_Model
{
	var $table = 'post';
	var $column_order = array('','post.title','post.description','material.material_name','post.location','post.status'); //set column field database for datatable orderable
	var $column_search = array('post.title','post.description','material.material_name','post.location','post.status');
	
  	function __construct() {
	 	parent::__construct(); 
  	} 
	
	public function get_data($id) {
		$this->db->select('a.*');
		$this->db->from('post as a');
		$this->db->where('post_id', $id);
		$query = $this->db->get();
		return $query->row();

	}
	public function get_all_materials() {
		$this->db->select('*');
		$this->db->from('material');
		$query = $this->db->get();
		return $query->result();

	}
    public function get_all_users() {
		$this->db->select('*');
		$this->db->from('users');
		$query = $this->db->get();
		return $query->result();

	}
	
	public function get_list()
	{
		$this->db->select('*');
		$this->db->from('post');
		$query = $this->db->get();
		return $query->result();
	}
	
	public function insert($data) { 
	    //echo "<br> Insert";
		 
		if ($this->db->insert("post", $data)) { 
			return true; 
		}else{
		 	return false;
		}
	} 
	public function update($data,$id) { 
		$this->db->set($data); 
		$this->db->where("post_id", $id); 
		
		if ( $this->db->update("post", $data)) {  
		 return true; 
		}else{
		 return false;
		}
	} 
	
	public function delete($id) { 
		$this->db->where('post_id', $id);
		if ($this->db->delete("post")) { 
			return true; 
		}else{
			 return false;
		}
	} 

	public function update_status($id, $statusData) {
		$arrIds = explode(",",$id);
		$this->db->where_in('post_id', $arrIds);
		$update = $this->db->update('post', $statusData);
		return ($update==true)?true:false;
	}
	
	private function _get_datatables_query()
{
    $this->db->select('post.*, material.material_name');
    $this->db->from('post');
    $this->db->join('material', 'material.material_id = post.material_type', 'left');
    $i = 0;
    foreach ($this->column_search as $item) {
        if ($_POST['search']['value']) {
            if ($i === 0) {
                $this->db->group_start();
                $this->db->like($item, $_POST['search']['value']);
            } else {
                $this->db->or_like($item, $_POST['search']['value']);
            }
            if (count($this->column_search) - 1 == $i) {
                $this->db->group_end();
            }
        }
        $i++;
    }
   	// add this line to order by date_added in descending order
		if(isset($_POST['order'])) {
		$order_column_index  = $_POST['order']['0']['column'];
		$order_column_name = $this->column_order[$order_column_index];
		$order_dir = $_POST['order']['0']['dir'];
		$this->db->order_by($order_column_name, $order_dir);
		} else if(isset($this->order)) {
		$order = $this->order;
		$this->db->order_by(key($order), $order[key($order)]);
	}
}
	public function get_datatables()
	{
		$this->_get_datatables_query();
		if($_POST['length'] != -1)
		$this->db->limit($_POST['length'], $_POST['start']);
		
		$query = $this->db->get();
		//echo "SQL:" . $this->db->last_query();
		return $query->result();
	}
	public function count_filtered()
	{
		$this->_get_datatables_query();
		$query = $this->db->get();
		return $query->num_rows();
	}
	public function count_all()
	{
		$this->db->from($this->table);
		return $this->db->count_all_results();
	}

}
?>